#ifndef UWATER_FRAME_APP_H
#define	UWATER_FRAME_APP_H

#ifdef	__cplusplus
extern "C" {
#endif
	
#include "type.h"
#include "UWater_gp22_driver.h"
#include "UWater_uart_driver.h"
#include "UWater_rtcc_driver.h"
#pragma pack(1) //1ֽڶ

/**
Ӳ汾:λʾǷ¶Ȱ

汾:4λʾ
bit31    bit30    bit29    bit28    
         [:ˮ3-ˮ4----]  		 
**/
#define BOOTLOADER_VERSION  0x3030314E   //Զ汾ţN1.00AASCALL
#define FM_HEAD_MARK        0x68                    //֡ͷ
#define MET_TYPE            0x10                    // 0x10ˮ
#define MET_TYPE_TCP        0x20                    // 
#define MET_TYPE_SY         0x02                    // ԼΪԼ汾Ϊ02H 20211025
#define FM_END_MARK         0x16                    //֡β
#define MAX_NB              500                     //NBݻֵ
#define FM_MAX_BUF_NUM      500                     //ͻֵ

/*ϵ2020-07-08*/
//ϵֺ궨
#define FLOW_COEFFICIENT_BUF_NUM      18  //ϵĸ
#define LOW_TYPE        0x77
#define MIDDLE_TYPE     0x88
#define LARGE_TYPE      0x99
#define ALL_TYPE        0xAA
#define FLOW_COEFFICIENT_MAX  72089
#define FLOW_COEFFICIENT_MIN  58982
//һϵ־
#define FIRST_POWER_ON_FLAG  0X55




#define EEP_FRAME_BASE_ADDR                     0x00
#define EEP_FRAME_FIRST_POWER_ADDR              (EEP_FRAME_BASE_ADDR + 0)                     //1byte     //һϵ־ַ
#define EEP_FRAME_STARTUSING_ADDR               (EEP_FRAME_FIRST_POWER_ADDR + 1)              //1byte     //ñ־1ֽ
#define FRAME_NBIot_FREQVAL		                (EEP_FRAME_STARTUSING_ADDR  + 1)	            //ϱƵ5ֽ  add by wm 2017.07.19
#define FRAME_NBIot_IP                          (FRAME_NBIot_FREQVAL+5)                       //ip 4ֽ 
#define FRAME_NBIot_PORT                        (FRAME_NBIot_IP+4)                            //ö˿ 2ֽ 
#define FRAME_NBIot_REPORTSTART                 (FRAME_NBIot_PORT+2)                          //ϱʼʱ 6ֽ 
#define FRAME_NBIot_REPORTEND                   (FRAME_NBIot_REPORTSTART+6)                   //ϱʱ 6ֽ 
#define FRAME_NBIot_LENGTH                      (FRAME_NBIot_REPORTEND+6)                     //ϱСֵ2ֽ
#define EEP_RETRY_TIMES_ADDR                    (FRAME_NBIot_LENGTH + 2)                      //Դ1ֽ
#define FRAME_NBIot_STARTTIME                   (EEP_RETRY_TIMES_ADDR+1)                      //ܼϱʱ 9ֽ
#define FRAME_NBIot_HIGHFLOW                    (FRAME_NBIot_STARTTIME+9)                     //ֵ 4ֽ
#define FRAME_VALVE_PRA                         (FRAME_NBIot_HIGHFLOW+4)                      //ز 4ֽ
#define FRAME_VALVE_EMERGENCY_FLOW              (FRAME_VALVE_PRA +4)                          //Ӧˮ  2ֽ
#define FRAME_NBIot_fre                         (FRAME_VALVE_EMERGENCY_FLOW+2)                //Ƶ2ֽ
#define FRAME_NBIot_APN                         (FRAME_NBIot_fre+2)                           //APN 20ֽ
#define FRAME_NBIot_KEY                         (FRAME_NBIot_APN+20)                          //ͨԿ, 16ֽ
#define EEP_FRAME_MAC_ADDR                      (FRAME_NBIot_KEY + 16)                        //7bytes    //ַ׵ַ
#define EEP_FRAME_SER_NUM_ADDR                  (EEP_FRAME_MAC_ADDR + 7)                      //7bytes    //к׵ַ
#define EEP_FRAME_MET_ADDR                      (EEP_FRAME_SER_NUM_ADDR + 7)                  //7bytes    //ͨѶַ׵ַ
#define EEP_FRAME_SOLIDIFY_MAC_ADDR             (EEP_FRAME_MET_ADDR + 7)                      //1byte     //ַ̻־ַ
#define EEP_FRAME_BOOTLOADER_INFO_ADDR          (EEP_FRAME_SOLIDIFY_MAC_ADDR + 1)             //5bytes    //ԶϢ׵ַ
#define EEP_FRAME_ENABLE_BAK_KEY_ADDR           (EEP_FRAME_BOOTLOADER_INFO_ADDR + 5)          //1bytes    //ñԿ־ַ
#define EEP_FRAME_LAST_KEY_NUM                  (EEP_FRAME_ENABLE_BAK_KEY_ADDR + 1)           //1byte     //num´ͨѶԿnum
#define EEP_FRAME_TEMPERATURE_COEFFICIENT_ADDR  (EEP_FRAME_LAST_KEY_NUM + 1)                  //8bytes    //¶ϵ׵ַ
#define EEP_FRAME_FLOW_COEFFICIENT_ADDR         (EEP_FRAME_TEMPERATURE_COEFFICIENT_ADDR + 8)  //24bytes   //ϵ׵ַ
#define EEP_FRAME_VERIFICATION_FUNCTION_ADDR    (EEP_FRAME_FLOW_COEFFICIENT_ADDR + 24)        //1byte     //ü춨ַܵ
#define EEP_FRAME_INFRARED_FUNCTION_ADDR        (EEP_FRAME_VERIFICATION_FUNCTION_ADDR + 1)    //1byte     //ú⹦ַܵ
#define EEP_FRAME_FUNCCFGBYTES_ADDR             (EEP_FRAME_INFRARED_FUNCTION_ADDR + 1)        //32bytes   //ֽ 
#define EEP_FRAME_START_FLOW_ADDR               (EEP_FRAME_FUNCCFGBYTES_ADDR + 32)            //2byte     //ʹ2ֽ---20191111Ŀ
#define EEP_FRAME_COUNTER_CURRENT_FLOW_ADDR     (EEP_FRAME_START_FLOW_ADDR + 2)               //2byte     //2ֽ---20191111Ŀ
#define EEP_FRAME_SAMPLING_FREQUENCY_ADDR       (EEP_FRAME_COUNTER_CURRENT_FLOW_ADDR + 2)     //1byte     //Ƶ1ֽ---20191113Ŀ
#define EEP_FRAME_SAMPLING_BUF_LEN_ADDR         (EEP_FRAME_SAMPLING_FREQUENCY_ADDR + 1)       //1byte     //С1ֽ---20191113Ŀ
#define EEP_FRAME_STORAGE_FREQUENCY             (EEP_FRAME_SAMPLING_BUF_LEN_ADDR + 1)         //1byte     //ܼ洢(0:30s,1:1min,2:2min,3:3min...)
#define EEP_FRAME_JX_SAMPLING_FREQUENCY_ADDR    (EEP_FRAME_STORAGE_FREQUENCY + 1)             //2byte     //ԼƵ(byte1,ͲƵ;byte2,߲Ƶ)
#define EEP_FRAME_JX_PSM_PWDOWN_ADDR            (EEP_FRAME_JX_SAMPLING_FREQUENCY_ADDR +2)     //1byte     //ԼNBģPSMϵģʽѡ(0,psm;1,power down)
#define EEP_FRAME_NB_PARA_ADDR                  (EEP_FRAME_JX_PSM_PWDOWN_ADDR + 1)            //4byte     //NBԼʱͷȴʱ
#define FRAME_NBIot_BUBAO_FLAG                  (EEP_FRAME_NB_PARA_ADDR+4)                    //6byte //¼ҪݡһλӦһݰ;Լдʷָ 6ֽ 
#define FRMAE_REMAIN_EMERGENCY_FLOW             (FRAME_NBIot_BUBAO_FLAG+6)                    //4byte ʣӦˮ
#define EEP_BLE_PARA_VOLTAGE                    (FRMAE_REMAIN_EMERGENCY_FLOW+4)               //4byte Ƿѹֵ4ֽ
#define EEP_FRMAE_BATTERY_ENERGY                (EEP_BLE_PARA_VOLTAGE+4)                      //18byte ص 


////Ҫ FRAME_MET_INFO Ӧ

#define EEP_GP30_BASE_ADDR                   0X100
/*#define	DIFTOF_CALIBRATION_FLAG_ADDR			  0X150 //2021,04,ӻУ׼־0xA1B2C3D4E5F6A7B8ʾУ׼
#define	DIFTOF_CALIBRATION_VALUE_ADDR			  DIFTOF_CALIBRATION_FLAG_ADDR +8 //2021,04,ӻУ׼ֵ4ֽ*/
#define EEP_RTCC_APP_USE_ADDR                0X180

#define FRAME_FLOW_COEFFICIENT_ADDR       	 0x200               //ʽģϵ߹5*11*4ֽ

#define EEP_BOOTLOAD_START              0X300
#define EEP_MCU_TYPE                    EEP_BOOTLOAD_START  //mcuƽ̨
#define EEP_MCU_MODEL                   (EEP_MCU_TYPE+1)            //mcuͺ,1 ֽ   
#define EEP_PRODUCT_MODEL               (EEP_MCU_MODEL+1)           //Ʒͺ,1ֽ 
#define EEP_HARDWARE_VERSION            (EEP_PRODUCT_MODEL+1)       //Ӳ汾,1ֽ 
#define EEP_SOFT_VERSION                (EEP_HARDWARE_VERSION+1)    //汾,4ֽ 
#define EEP_UPDATE_NUM                  (EEP_SOFT_VERSION+4)        //ֽ,4ֽ 
#define EEP_UPDATE_CHECK                (EEP_UPDATE_NUM+4)          //У,2ֽ 
#define EEP_UPDATE_VER                  (EEP_UPDATE_CHECK+2)        //汾,2ֽ 
#define EEP_UPDATE_FLAG                 (EEP_UPDATE_VER+2)          //Ƿ־,1ֽ 
#define EEP_UPDATE_SOURSE               (EEP_UPDATE_FLAG+1)         //Դ,1ֽ 
#define EEP_UPDATE_PKNUM                (EEP_UPDATE_SOURSE+1)       //,2ֽ 
#define EEP_UPDATE_RSSI                 (EEP_UPDATE_PKNUM+2)        //źǿ,1ֽ 
#define EEP_UPDATE_UDP_IP               (EEP_UPDATE_RSSI+1)         //4bytes,UDPIPַ
#define EEP_UPDATE_UDP_PORT             (EEP_UPDATE_UDP_IP+4)       //2bytes,UDP˿ں

#define EEP_BASE_VALVE                  (EEP_BOOTLOAD_START+40)    //ſ,2ֽ 20180903

#define FRAME_FLOW_LOW_COEFFICIENT_ADDR            0x340 //72ֽ,ϵַ  2020-07-08
#define FRAME_FLOW_MIDDLE_COEFFICIENT_ADDR         (FRAME_FLOW_LOW_COEFFICIENT_ADDR + 24)//ϵLOWַƫ24ֽڴ洢20~35ֵ
#define FRAME_FLOW_HIGH_COEFFICIENT_ADDR           (FRAME_FLOW_MIDDLE_COEFFICIENT_ADDR + 24)//ϵMIDDLEַƫ24ֽڴ洢35漰ֵ

#define EEP_RTCC_APP_HISTORY_ADDR            0x440  //0x440~0x823
#define EEP_SOE_ADDR                        0x1000 //SOE洢ַ

#define FRAME_NBIot_HISTORY_READ_ADD            0x2000 //洢ʷݻַ  
#define FRAME_QUANZHOU_STORE_ADD                0x4000 //ȪĿݴ洢ַ
#define FRAME_SHENYANG_STORE_ADD                0x7300 //Ŀݴ洢ַ

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//ʽģֺ궨
#define MULT_COEFFICIENT_BUF_NUM      	55				//ʽģϵĸ
#define COEFFICIENT_MAX      			(float)1000 				//ʽģϵĺϷֵ
#define COEFFICIENT_MIN      			(float)-1000 				//ʽģϵĺϷСֵ


typedef union 
{
	UNION_4U8TOU32 float_storage_format;
	float float_datas;
} UNION_FLOAT_STORAGE;


typedef union
{
	uint8_t value[4];
	uint32_t value_u32;
	float  flt;
} TYP_FLOW_COEFFICIENT;

typedef union {
	struct 
	{
		u8  type;     ///·λ޷HEX0ʾ1ʾ
		u8  period;   //޷HEXֵΪ촫ֶαʾ졣Ϊ´ֶαʾÿµļ
		bcd hour;     //ϴʱ䣬BCD룬ʾʱ
		bcd minute;   //ϴʱ䣬BCD룬ʾ֡
		bcd second;
	}s;
    u8 buf[5];
} Time_upload;//ʱϴ

typedef union
{
	struct
	{
		u8 valve_state;          			//״̬
		u8 valve_err;        				//쳣
		u8 valve_total_time;				//طʱ
		u8 valve_AD;						//תADֵ
	};
	u8 byte[4];
} IES_VALVE_PARAS;	//ز

typedef union
{
	struct
	{
		u8 valve_up_times_pre;       		//Լ趨Ƶ-طϱ
		u8 valve_up_times_total;     		//Լ趨Ĵ-طϱ
		u8 valve_up_times_realtime;   		//ʵʱϱĴ-طϱ
		u8 valve_auto_check;				//ÿ·Լ칦ǷAAʾ
		u8 reserv;//Ԥֽ
	};
	u8 byte[5];
} IES_VALVE_UP_TIMES;						//طϱ

extern TYP_FLOW_COEFFICIENT  cal_coefficient[MULT_COEFFICIENT_BUF_NUM];
extern const float default_coefficient[MULT_COEFFICIENT_BUF_NUM];
extern UNION_4U8TOU32  cal_flow_coefficient[FLOW_COEFFICIENT_BUF_NUM];//ʽϵ
extern const u32 default_flow_coefficient[FLOW_COEFFICIENT_BUF_NUM];//

typedef struct 
{
	u8 ble_tx_power; 
	u8 ble_adv_fre; 
	u8 ble_con_para; 
	u8 ble_scan_times;
	u8 password_enable;
} BLE_FUNC_SW; 
typedef struct
{
	mtype32_ total_use_sum_times_sec;
	mtype32_ bat_surplus;
	mtype32_ use_sum_times_sec;
	mtype32_ nb_use_sum_times_sec;
	u16 nb_upload_happen_num;
	u16 valve_use_sum_times_sec;
	float ee_remain_para_energy_life;
}STR_RUN_INFO;

typedef struct 
{
	u8 first_power_flg;              //һϵ־---------------------1
	u8 start_using_flg;              //ñ־-----------------------1	
	Time_upload Time_upload_2006; //ʱϴ//ϱƵ5--------------------------5ֽ벻			        
	u8 server_ip[4];		             //ipַ4----------------------------4
	UNION_2U8TOU16 server_port;		   //˿ں2----------------------------2
	u8 report_period_start[6];	     //ϱʼʱ䣬ʱ6----------6
	u8 report_period_end[6];	       //ϱʱ䣬ʱ6----------6
	UNION_2U8TOU16 report_step_len; //UNION_2U8TOU16 report_step_len;//ϱСֵ2-----------------2// ʱ λ룬Χ15~43.ʱϴ巽ʱϴʱ + ź3λ ʱ + 60롣	    
	u8 report_retry_times;        //u8 report_retry_times;		  //Դ	1  		--------------------1
	u8 report_start_time[9];	       //ܼϱʼʱ䣬ʱ?9-----------9
	UNION_4U8TOU32 high_flow_alarm;	 //ֵ4-------------------4
	IES_VALVE_PARAS ies_valve_paras;//ز u8 ss_bak[6];//Ԥ6ֽ------------------------4
	UNION_2U8TOU16 ies_pulse_emergency; //Ӧˮ----------------------2
	UNION_2U8TOU16 report_fre;       //Ƶ2-------------------------------2
	u8 apn[20];			                  //APN,	20	------------------------20
	u8 key[16];                       //ͨԿ---------------------------16
	u8 mac_addr[7];                   //ַ----------------------------7                   
	u8 ser_num[7];                    //к------------------------------7                     
	u8 met_addr[7];                   //ͨѶַ----------------------------7  
	u8 solidify_mac_addr_flg;         //ַ̻ʶ---------------------1 
	IES_VALVE_UP_TIMES ies_valve_up_times;//طϱ-----------------5 
	u8 enable_bak_key;                //ñԿ--------------------------1
	u8 last_key_num;                  //´ͨѶԿnum---------------------1 
	UNION_4U8TOU32 temperature_coefficient0; //¶ϵ0---------------------4 
	UNION_4U8TOU32 temperature_coefficient1; //¶ϵ1---------------------4
	UNION_4U8TOU32 flow_coefficient_small; //Сϵ----------------------4//0x00010000
	UNION_4U8TOU32 flow_coefficient_middle0; //ϵ0-------------------4//0x00010000
	UNION_4U8TOU32 flow_coefficient_middle1; //ϵ1-------------------4//0x00010000
	UNION_4U8TOU32 flow_coefficient_middle2; //ϵ2-------------------4//0x00010000
	UNION_4U8TOU32 flow_coefficient_middle3; //ϵ3-------------------4//0x00010000    //20161021
	UNION_4U8TOU32 flow_coefficient_large; //ϵ----------------------4//0x00010000
	u8 enable_verification_function; //ü춨--------------------------1//0x5A
	u8 enable_infrared_function; //ú⹦------------------------------1//0x5A		
	u8 func_cfg_bytes[32];      //ֽ------------------------------32
	//Ŀ-20191108-ʼأ4ֽڣ
	UNION_2U8TOU16 start_flow;//ʹ2ֽ--------------------------------2
	UNION_2U8TOU16 counter_current_flow; //----------------------2
	u8 sampling_frequency; //Ƶ----------------------------------------1                              
	u8 buf_length; // BUFF--------------------------------------------------1
	u8 storage_frequency;//ܼ洢--------------------------------------1 
	u8 jx_sampling_frequency[2];//ԼƵ---------------------------2
	u8 jx_psm_pwdown;//ԼNBģPSMϵģʽѡ------------------------1
	UNION_2U8TOU16 Upload_again_interval_time;//UNION_2U8TOU16 nb_para_retry_delay;           //ʱ
	UNION_2U8TOU16 nb_para_login_ask_times;   //Ӹʱ(ѯcereg)
	UNION_4U8TOU32 Supplemental_send_flag;           //־¼ÿϱɹ¼һbitಹ30¼   
    u8 histroy_r;//ʷݵĶָ ʷݴ洢ָ   
    u8 histroy_w;//ʷݵдָ ָ
	UNION_4U8TOU32 ies_pulse_remain; //ӦˮӦﵽֵ4	
	u8 voltage_low[4];//Ƿѹֵ
	STR_RUN_INFO run_information_object;
}FRAME_MET_INFO;

typedef struct 
{
	union 
	{
		struct 
		{
			u8 transducer_aging : 1; //ϻ
			u8 flow_err : 1; //ǰ>Q4<Q1					
			u8 rtcc_time_err : 1; //RTCCʱ쳣
			u8 nbsend_err : 1; //GPxx쳣
			u8 nbrec_err  :1;
			u8 water_overheating : 1; //ˮ³¶ȵȼΧ
			u8 gp22_commun_fail:1;//GP22ͨʧ
			u8 nouse1 : 1;
		} stat0bits;
		u8 stat0;
	};
	union 
	{
		struct 
		{
			u8 reverse : 1; //ת
			u8 low_flow_rate : 1; //
			u8 none_water : 1; //ܵˮ
			u8 diftof_calibration_switch : 1; //У׼ر־
			u8 transducer_check_abnormal : 1; //ܴ쳣ı־
			u8 low_battery_voltage : 1; //Ƿѹ
			u8 valve_state : 2; //״̬
		} stat1bits;
		u8 stat1;
	};
	union 
	{
		struct 
		{
			u8 met_type: 1;//ͣ10ͨ
			u8 nouse : 7;
		} stat2bits;
		u8 stat2;
	};
	union 
	{
		struct 
		{
			u8 met_type : 1; 													
			u8 nbrec_err  :1;			
			u8 gp22_commun_fail:1;//GP22ͨʧ
			u8 rtcc_time_err : 1; //RTCCʱ쳣
			u8 nbsend_err : 1; //GPxx쳣
			u8 water_overheating : 1; //ˮ³¶ȵȼΧ
			u8 flow_err : 1; //ǰ>Q4<Q1	
			u8 transducer_aging : 1;//ϻ
		} stat3bits;
		u8 stat3;
	};
	union 
	{
		struct 
		{
			u8 nouse : 8;
		} stat4bits;
		u8 stat4;
	};
} MET_STATE; //״̬
typedef struct 
{
	union 
	{
		struct 
		{
			u8 reverse : 1; //ת
			u8 low_flow_rate : 1; //
			u8 valve_state : 2; //״̬
			u8 remain_warning:1;//
			u8 release : 2; //
			u8 ntc_state:1; //NTC쳣־
		} statTcp1bits;
		u8 statTCP1;
	};
	union 
	{
		struct 
		{
			u8 remain_state : 1; //Ϊ
			u8 low_power : 1; //Ƿѹ
			u8 release : 2; //
			u8 amplitude : 4;//ֵλ
		} statTcp2bits;
		u8 statTCP2;
	};
} TCP_STATE; //״̬
	
 typedef union            //ǿתΪ
{
    u32   gp22_u32;
    float gp22_float;
} Fram_To_Float;
typedef struct 
{
	u8 data_sourse; //ϢԴ0uart  1rf
	u8 enc_reply_flg; //Ӧ־1Ч
	u8 enc_tmp_addr[7]; //ַ֡ܵݴ棬Ӧ
	u8 rev_key_num; //λnumֵ
} STRUCT_FLAG; //ڲ־λ
/************************************************ԼϢ**********************************/
typedef struct 
{
	u8 set_verification_msg; //춨0
	u8 clear_realtime_data_msg; //ʵʱ1
	u8 clear_work_time_msg; //ۼƹʱ2
	u8 bootloader_msg; //Զ3
	u8 measure_hydrostatic_jet_lag_msg; //⾻ˮʱ4----------û
	u8 clear_history_data_msg; //ʷ5
	u8 channel_change_msg; //ŵл6-------------------------û
	u8 start_188fm_route_msg;//188Լݴ7----------------û
	u8 change_link_addr_msg;    //·ַ8----------------û
	u8 change_route_mettype_msg;    //ͱ9----------------û
	u8 check_active_time_msg;   //ҪԾmsgϵߵݴʱ䡢ʱα䣩10
	u8 calibrate_time_rfapp_msg;  //Уʱmsgrtappλ״̬־11
	u8 calibrate_rtc_msg;           //RTCУ׼msg 12
	u8 valve_ctrl_msg;          //msg  13------------------û
	u8 static_measure_init_msg; //ˮʼmsg 14----------û
	u8 low_power_msg;           //Ƶ͹msg  15
	u8 out_verification_msg;    //춨msg  16
	u8 lcd_display_all_msg;    //ȫ  17
	u8 initial_data_msg;     //³ֵ־ 18
	u8 model_change_msg;//лʹ 19
	u8 valve_open_msg;//20
	u8 valve_close_msg;//ط21
	u8 valve_half_msg;//뿪22
	//NBϱص
	u8 msg_nb_UploadFreqChange;//ϱƵʸı
	u8 msg_nb_IpPort_change;//IP Portı  
	u8 msg_nb_StartEnd_change;//ϱʼͽʱı
	u8 msg_nb_StepLength_change;//ֵı
	u8 msg_nb_RetryTimes_change;//Դı
	u8 msg_nb_IntensiveTime;//ܼϱ
	u8 msg_nb_FlowAlarm;//ֵ
	u8 msg_nb_UartSend;//ڷϴ
	u8 msg_nb_SoftUpdate;//Ϣ
	u8 msg_nb_Apn_change;//APN
	u8 msg_updatesoft_version_ok;//ж汾ȷ
	u8 msg_rtcc_adjust_time;//RTCУʱϢ
	u8 msg_nb_upload_ack_ok;//NBϴӦɹ
	u8 msg_nb_uoload_faild;//NBϴʧ
    u8 msg_caliberate;//ƵʱУ׼־
} STRUCT_MSG; //msg

typedef enum
{
    SetVerificationMsg = 0, //춨0
	ClearRealtimeDataMsg = 1,   //ʵʱ1 
	ClearWorkTimeMsg = 2,       //ۼƹʱ2
	BootloaderMsg = 3,          //Զ3 
	MeasureHydrostaticJetLagMsg = 4, //⾻ˮʱ4
	ClearHistoryDataMsg = 5,//ʷ5 
	ChannelChangeMsg = 6,//ŵл6  
	Start188FmRouteMsg = 7,//188Լݴ7 
	ChangeLinkAddrMsg = 8,//·ַ8
	ChangeRouteMettypeMsg = 9,//ͱ9 
	CalibrateRtcMsg = 12,//RTCУ׼msg 12
	ValveCtrlMsg = 13,//msg  13
	StaticMeasureInitMsg = 14,//ˮʼmsg 14
	LowPowerMsg = 15,//Ƶ͹msg  15 
	OutVerificationMsg = 16,//춨msg  16   
	LcdDisplayAllMsg = 17,//ȫ  17  
	InitialDataMsg = 18,//³ֵ־ 18  
	ModelChangeMsg = 19,//лʹ 19 
	ValveOpenMsg = 20,//20 
	ValveCloseMsg= 21,//ط21
	ValveHalfMsg = 22,//뿪22
	//NBϱص
	MsgNbUploadFreqChange=23,//ϴ
	MsgNbIpPortChange=24,//IP Portı
	MsgNbStartEndChange=25,//ϱʼͽʱı
	MsgNbStepLengthChange=26,//ֵı
	MsgNbRetryTimesChange=27,//Դı
	MsgNbIntensiveTime=28,//ܼϱ
	MsgNbFlowAlarm=29,//ֵ
	MsgNbUartSend=30,//ڷϴ
	MsgNbSoftUpdate=31,//Ϣ
	MsgNbApnChange=32,//APN
	MsgUpdateSoftVersionCheckOk=33,//ж汾ȷ
	MsgRtccAdjustTime=34,//RTCУʱϢ
	MsgNbUplaod_AckOk=35,//NBϴӦɹ
	MsgNbUploadFailed=36,//NBϴʧ
	MsgNbUploadRetryMsg=37,//NBϴʼ
	MsgSaveHisIndex=38,//дָ
	MsgSaveBubaoFlag=39,//油־ 
	MsgClearNbDebugFlag=40,//رպӡ
	MsgOpenIr=41,//򿪺ͨ
	MsgRtccEvenHour=42,//żʱ䵽
	MsgValve_EmergencyFlowStore=43,//ӦˮϢ
	MsgTouchKeyReset = 44,
	MsgNbUplaod_AckLoginOk=45,//NBϴӦɹ
	MsgCaliberate = 46,//ƵʱУ׼־
	///////////////////Ȫ
	MsgQuanzhou_DailySave=47,//նݴ洢Ϣ
	MsgQuanzhou_MonthSave=48,//¶ݴ洢Ϣ
	///////////////////ɳ
	MsgChangcha_ValveUploadCnts=49,//طϱϢ
	MsgTchKey_ClearKeyLimit=50,//Ϣ
	//////////////////״̬лʱϱ
	MsgNbUploadByValveStateChange = 51,
	MsgNb_SaveHis=52,//¼Ϣ
	MsgNbUpload_OffLine = 53,//
	MsgValveCloseSaveFlow = 54,//طλֵǰ
	MsgValveCloseSuccess  = 55,//طλ
	MsgValveOpenSuccess  =56,//λ
	//////////////////
	MsgShenYang_DailySave=57,//նݴ洢
	MsgShenYang_MonthSave=58,//¶ݴ洢
	MsgShenYang_YearSave=59,//궳ݴ洢
	MsgShenYang_CircleSave=60,//ݴ洢
	MsgShenYang_FrozenClear=61,//
	MsgShenYang_CircleClear=62,//
	MsgShenYang_WarningClear=63,//
	MsgShenYang_FactorySettingAndReset=64,//ָò
	MsgShenYang_SysReset=65,
	MsgShenYang_WarningCheck=66,//鱨״̬
	MsgShenYang_WarningStoreReset=67,
	MsgShenYang_NbUploadWarning = 68,//ϱ
	MsgShenYang_NbUploadWarningWithCircle = 69,//ϱ
	MsgShenYang_NbUplaod_AckOk=70,//NBϴӦɹ
	MsgShenYang_UdpIpPortChange=71,//UDP IP Portı
	/////////////////////////
	MsgNb_FlagRcvNbFrame=72,//յָ
	MsgSS_JianGeStore=73,//洢
	Msg_FrozenStore=74,//洢
	Msg_ClearHisOther=75,//ݸԼϢ
	Msg_ValveOpenEmergency=76,//Ӧ
	Msg_WdtReset=77,//ŹλϢ
	Msg_Por5VReset=78,//ǷѹӲλ
	MsgSS_HisIndexStore=79,//ָ洢
	MsgBLE_AdvChange=80,//㲥޸
	MsgBLE_ReadData=81,//Ϣ
	MsgBLE_RevData=82,//յָϢ
	MsgAddr_Change=83,//ַ仯
	MsgBLE_ConfigChange=84,//ϵʼ
	MsgBLE_Clktrim=85,//ʱУ׼
	MsgBLE_OtaEnter=86,//OTA
	MsgBLE_OtaExit=87,//˳OTA
	Msg_PsmPowerCheck=88,//PSMԴ
	Msg_FactoryUpload=89,//ϱϢ
	Msg_FactoryBleActive=90,//
	
	Msg_AllCount=91
} Frame_MsgTypeDef;

#define FRAME_MSG_TYPE_CNT  Msg_AllCount

typedef union 
{
    STRUCT_MSG MsgStruct;
    u8 MsgBuf[FRAME_MSG_TYPE_CNT];
} UNION_MSG;  

void FrameSetMsgApp(Frame_MsgTypeDef msgType);
u8 FrameCheckMsgApp(Frame_MsgTypeDef msgType);
u8 FrameClearMsgApp(Frame_MsgTypeDef msgType);
/***************************************************************************************************/
/************************************************Լ**********************************/
typedef enum
{
  FramePara_DNx = 0, //ܶοھ
	FramePara_Tc0 = 1, //¶ϵ0
	FramePara_Tc1 = 2, //¶ϵ1
	FramePara_FcSmall = 3, //ϵsmall
	FramePara_FcMiddle0 = 4, //ϵMiddle0
	FramePara_FcMiddle1 = 5, //ϵMiddle1
	FramePara_FcMiddle2 = 6, //ϵMiddle2
	FramePara_FcLarge = 7, //ϵLarge
	FramePara_ReportStartDMY = 8, //ܼϱʼʱbcd
	FramePara_ReportStartSMH = 9, //ܼϱʼʱʱbcd
	FramePara_ProgVersion = 10,      //汾
	FramePara_MetAddr0_3 = 11, //ͨŵַ4ֽ
	FramePara_MetAddr4 = 12, //ͨŵַ1ֽ
	FramePara_FuncCfg0_3 = 13,//ܿ
	FramePara_FuncCfg4_7 = 14,//ܿ
	FramePara_FuncCfg8_11 = 15,//ܿ
	FramePara_FuncCfg12_15 = 16,//ܿ
	FramePara_ReportEndSMH = 17,//ܼϱʱbcd
	FramePara_FcMiddle3 = 18, //ϵMiddle3
	FramePara_Sta1_2 = 21,//״̬
	FramePara_CCFlow = 22,//
	FramePara_StartFlow = 23,//ʼ
	FramePara_GP30Freq = 24,//Ƶ
	FramePara_GP30BufLen = 25,//ֽ
	FramePara_ReportFreq = 30,//ϱƵ
	FramePara_EnableTestFunc = 31,//춨ܿ
	FramePara_EnableInfrareFunc = 32,//⹦ܿ
	FramePara_StartUsingFunc = 33,//
	FramePara_StoreFrequency = 34,//ܼ洢ʱ
	FramePara_SamplingFrequency = 35,//ԼƵ
    FramePara_PsmOrPwDown = 36, //ԼNBģPSMϵģʽѡ	
	FramePara_NbParaRetryDelay = 37, //NBģϱʱͷȴʱ
	FramePara_NbParaLoginAckTimes=38,
	FramePara_BootVersion = 39,//boot汾
	//
	FramePara_End = 40
} Frame_CheckParaTypeDef;
#define FRAME_PARA_BUF_LEN  (FramePara_End+1)
u32 FrameCheckParaApp(Frame_CheckParaTypeDef parameter);
void Frame_Para_Init(void);
/***************************************************************************************************/
typedef struct
{        
    u8 en_code;//Ƿܣ1Ϊ
    u8 add_num;//ܲλ
    u16 data_len;//յĳ
}ENCODE_VERIFY;

typedef struct
{
	u8 mcu;                //ƽ̨
	u8 mcu_model;          //MCUͺ
	u8 product_model;      //Ʒͺ
	u8 hardware_version;   //Ӳ汾
	u8 soft_version[4];    //汾
	UNION_4U8TOU32 update_num;        //ֽ
	UNION_2U8TOU16 update_check;      //У
	UNION_2U8TOU16 bootloader_ver;//汾
	u8 bootloader_update_flg;//Ƿ־
	u8 bootloader_datas_sourse;//Դ//0x01--	0x02--GPRS	0x03--С
	UNION_2U8TOU16 bootloader_paknum;// 
	//²ͨλ
	//ע⣬bootжϵ˿ں8081~8090֮䣬ԶUDPʽ;ԼIPַʱжϵ÷Χᱣ浽UDP IPEEַ
	u8 bootloader_RSSI; //źǿ
	u8 server_ip[4];		           //udpipַ4
	UNION_2U8TOU16 server_port;		 //udp˿ں2
	//ƵַϢEEв
	u8 bootloader_addr[7];//Ƶַ
}U_UPGRADE_INFO; //34ֽ

typedef struct
{
	u8 FirstPowerOnFlag;
	u8 ProductUpoadFailFlag;
	u8 ProductUploadFlag;
	BLE_FUNC_SW function_switch;//ܿ
	u8 NBSleepMode;
	u8 LCD_NoTestFlag;
}U_TEMP_INFO; 

typedef struct
{
	u8 Point_SOE_write; //SOE¼ָ
}U_SIGAL_DATA;

typedef union {

    struct {
        u8 first_flag; //һϵ־λ
        u32 work_hour; //ۼƹʱ
        DateTime start_time_up; //ʱ
        u16 day_history_addr;  //ʷݴ洢ָ
        u32 day_data;  //ۻ
    }data;
    u8 byte[18];
} RTCC_EE_DATA; //RTCC

typedef struct
{
	FRAME_MET_INFO P1;//ϵͳ
	U_UPGRADE_INFO P2;//UDPַ
	U_TEMP_INFO P3;//EEȫֲ
	U_SIGAL_DATA P4;
	RTCC_EE_DATA ee_data; 
	//GP30_DIFTOF_CAL_DATA P5;
} Data_object;//ݶ

//#define FLOW_ 0x2B1A

extern Data_object Sys_data_object;
//20211204
#if PF_TYPE_METER || EN_TYPE_METER || MID_TYPE_METER
extern float default_error_cruve[15][16];
#else
extern float default_error_cruve[12][16];
#endif 
extern float default_error_DXS[MULT_COEFFICIENT_BUF_NUM];

void FrameInitApp(void);
void FrameMachineApp(void);
//ˮԼʹ
void FrameSetSupplementalPack_Flag(u8 tempData);


u16 FrameCheckByte(void);
u8 FrameIfSleepApp(void);
MET_STATE FrameGetByte(void);
 u8 Save_histroy_ss_flag(u8 flag);
 u8 Clear_histroy_ss_flag(u8 ss_NO);
///////////////////////////////////		
u32 HexToBcd32(u32 value);
u32 Gp30DataToBcd(u32 data, u32 times);
/*************NB*************************/
TYP_FLOW_COEFFICIENT* ReadCofficientApp(void);
UNION_4U8TOU32* Read_Flow_CofficientApp(void);//2020-07-08 ϵ׵ַ
u32 Read_Flow_CofficientApp_For_LCD(u8 index);//2020-08-13 //䳣ϵA2Ļ
void fram_tools_writeU32ByBuf(u8 *pU32Buf, u8 *pSrc, u8 dir);
u8 frame_get_datasource(void);
void frame_set_key(void);

float Get_Temperature_Caliberate(void);//ȡ̨У׼¶
void SetCaliberateTemperature(u16 temp_value);//±׼¶
u8 GetNbiotRevHandleOverFlag(void);
void UWMetPtlPackApp(void);

#define UP_DEAL_S0      0
#define UP_DEAL_S1      1
#define UP_DEAL_S2      2
#define UP_DEAL_S3      3
#define UP_DEAL_S4      4
#define UP_DEAL_S5      5
#define UP_DEAL_S6      6
#define UP_DEAL_S7      7
#define UP_DEAL_S8      8
#define UP_DEAL_S9      9
#define UP_DEAL_S10     10
#define UP_DEAL_S11     11
#define UP_DEAL_S12     12
#define UP_DEAL_S13     13
#define UP_DEAL_S14     14
#define UP_DEAL_S15     15
#define UP_DEAL_S16     16
#define UP_DEAL_S17     17
#define UP_DEAL_S18     18
#define UP_DEAL_S19     19
#define UP_DEAL_S20     20
#define UP_DEAL_S21     21
#define UP_DEAL_S30     30
#define UP_DEAL_S31     31
#define UP_DEAL_S32     32
#define UP_DEAL_S33     33

#define UP_DEAL_S_OVER  99

//Լ״̬
typedef enum{
	UW_MET_PTL_IDLE=0,        //
	UW_MET_PTL_EXP,   	      //ԼֹԼ
	UW_MET_IES_PTL_PACK_S1,   //MBUSԼӦ֡
	UW_MET_MBUS_PTL_PACK_S1,  //NBԼӦ֡
	UW_MET_SHTCP_PTL_PACK_S1, //̺TCPԼӦ֡
	UW_MET_SYNB_PTL_PACK_S1, //NBԼӦ֡
	UW_MET_OTHER_PTL_PACK_S1,
	UW_MET_PTL_PACK_S2,  //ͨ
    UW_MET_PTL_PACK_S3,	//ͨжݷ
}TYP_STATE_MET_PTL_PACK;

/******************************************************************************/
#define QUEUE_BUF_SIZE    10     //
typedef struct 
{
	u8 type;
    u16 length;
	u8 buffer[128];
} ONE_PACK_DATA;

typedef struct 
{
	u8 handled_count;
	u8 total_count;
	ONE_PACK_DATA queue[QUEUE_BUF_SIZE];
} NBIOT_REV_QUEUE;

//Լͨ
#define UP_SOURCE_IR                0
#define UP_SOURCE_NB                1
#define UP_SOURCE_MBUS              2
#define UP_SOURCE_BLE               3
//Լ
#define IES_PTL                     1
#define MBUS_PTL                    2
//#define SHTCP_PTL                   3
//#define SYNB_PTL                    4  
#define OTHER_PTL                   5 
//Լ֡״̬
#define PTL_PACK_BUSY               0 
#define PTL_PACK_SUCCESS            1
#define PTL_PACK_FAIL               2

#ifdef	__cplusplus
}
#endif

#endif	/* GP30W_FRAME_APP_NEW_H */

