#include "sys_config.h"
#if PRODUCT_GS
#include "sys_processor.h"
#include "UWater_eeprom_driver.h"
#include "UWater_valve_driver.h"
#include "UWater_Valve_app.h"
#include "UWater_rtcc_app.h"
#include "UWater_power_app.h"
#include "UWater_gp22_app.h"
#include "UWater_pt_app.h" 
#include "UWater_DataTools_App.h"
#include "UWater_QZ_Store_App.h"
#include "UWater_frame_func_ReplyNB.h"
#include "UWater_frame_func_ReplyGuangShui.h"

static u8 s_eep_complete_GuangShui=0;
static u8 task_complete_GuangShui = PTL_PACK_BUSY;
static u8 g_frame_temp_buf_GuangShui[UP_BUF_SIZE];	//ݲֻ
static u16 g_frame_temp_len_GuangShui=0;
static DateTime GuangShui_rtcc_time;

static STRUCT_FRAME_IES frame_struct_GuangShui; //ԼϢ 
static u8 *new_message_data_rev_GuangShui; 
static u8 up_deal_stat_GuangShui = UP_DEAL_S0;//Լ״̬

static STRUCT_FRAME_GS  frame_struct_JM; //ˮԼϢ
/*******ϴر*****************************************/
static STRUCT_FRAME_IES upload_struct_GuangShui; //ԼϢ 
static u8 upload_frame_stat_GuangShui=0; //ϱ֡״̬
static u8 upload_task_complete_GuangShui = PTL_PACK_FAIL;  
static u16 upload_temp_len_GuangShui=0;//ϱݳ	
static UNION_SIGNAL signal_val;
static u8 *new_message_data_rev_jm;  //ָ
static DateTime rtcc_time_gs;
static u8 upload_packet_count=0; //ϴݰ
static u8 gs_upload_fail_times=0;//ϱʧܴ
static u8 upload_frame_retry_times=0; //ط
static u8 temp_upload_step=0; //ϱ״̬
static u8 temp_store_msg=0; //ݴ洢Ϣ

//ɹԼϱ
static STRU_UPLOAD_FRAME upload_frame;//֡ϱ
static STRU_UPLOAD_FRAME store_frame;//֡洢,ϱ֡,ֹϱڼ洢
//ˮԼϱ
static STRU_UP_FRAME_GS upload_frame_gs; 

//,洢
static TYP_STATE_SS step_save_supplt=SS_STATE_S0; 
static RTCC_To_Float old_jiange_total_flow;
static RTCC_To_Float new_jiange_total_flow;
static RTCC_UNION_2U8TOU16 jiange_data;
//־洢
static TYP_STATE_SS step_clear_flag=SS_STATE_S0; 
//ʱ洢ϱ
static u8 ls_save= FALSE;
static u8 ls_up= FALSE;
static u8 ls_save_cnt=0;
static STRU_UP_FRAME_GS ls_save_buf[6];//24Сʱ,5Ӽ洢
static RTCC_To_Float old_gs_total_flow;
static RTCC_To_Float new_gs_total_flow;
static u8 ls_upload_index=0;
static u8 ls_upload_flag=0;

//ʷݴ洢ر 
static UNION_GS_STORE_INDEX  his_save_para;
static u16 save_his_interval_cnt=0;
static TYP_STATE_SS his_save_step=SS_STATE_S0; 
static RTCC_To_Float his_save_flow_value;
static u16 his_save_addr = EEP_ADDR_HIS_DATA;
static u8 his_save_flow_buf[5];
//ʷݶȡر
static u16 his_read_start_count=0;
static u16 his_read_end_count=0;
static u8  his_read_count;
static u16 his_read_addr = EEP_ADDR_HIS_DATA;
static u8  his_read_flow_buf[5];
static u8  his_read_check;
static DateTime          his_read_start_time;
static UNION_2U8TOU16    his_read_period;
static RTCC_To_Float     his_read_new_flow;
static RTCC_To_Float     his_read_old_flow;
static SS_UNION_4U8TOU32 his_read_tempData;
static u8 his_read_tempBuf[6];
static long temp_diff_time;
//ϱ
static UNION_GS_UPLOAD_PARA linshi_jm; //ʱ洢ϱ
static DateTime rtcc_linshi_jm; //¼ʱϱĿʼʱ
static u8 linshi_data_eff=0; //¼ʱ洢ϱı־

//ݸʽת
static void  u32HEXtoBCDData(u32 uiHEXdata,u8*ucBCDdata )
{
	u8 ucHEXdata[10] = {0};
	//2ֽʮתBCD룬2ֽʮֵΪ0xffff=65535תBCDҪ3ֽװ
	ucHEXdata[1] = uiHEXdata%100;
	ucBCDdata[0] = (ucHEXdata[1]/10)*0x10 + (ucHEXdata[1]%10);
	uiHEXdata = uiHEXdata/100;
	ucHEXdata[2] = uiHEXdata%100;
	ucBCDdata[1] = (ucHEXdata[2]/10)*0x10 + (ucHEXdata[2]%10);
	uiHEXdata = uiHEXdata/100;
	ucHEXdata[3] = uiHEXdata%100;
	ucBCDdata[2] = (ucHEXdata[3]/10)*0x10 + (ucHEXdata[3]%10);

	uiHEXdata = uiHEXdata/100;
	ucHEXdata[4] = uiHEXdata%100;
	ucBCDdata[3] = (ucHEXdata[4]/10)*0x10 + (ucHEXdata[4]%10);		
	uiHEXdata = uiHEXdata/100;
	ucHEXdata[5] = uiHEXdata%100;
	ucBCDdata[4] = (ucHEXdata[5]/10)*0x10 + (ucHEXdata[5]%10);		
	uiHEXdata = uiHEXdata/100;
	ucHEXdata[6] = uiHEXdata%100;
	ucBCDdata[5] = (ucHEXdata[6]/10)*0x10 + (ucHEXdata[6]%10);				
}

//ʷ
static void frame_func_reply_NB_ReadHistoryData(void)
{
    u8 temp = 0;
    u8 temp_read_index = 0;
    u8 temp_read_code = *new_message_data_rev_GuangShui;   

    switch(up_deal_stat_GuangShui)
    {
        case UP_DEAL_S0:
        {
			if(TASK_IDLE == EepIfIdle())//ȡʷ
			{
				g_frame_temp_len_GuangShui =0;
				temp_read_index = NB_SS_Control_GetPara(NB_HistroyReadIndex);
				if (temp_read_index >= temp_read_code)
				{
					temp = temp_read_index - temp_read_code;
				}
				else
				{
					temp = 32 - (temp_read_code - temp_read_index);
				}
				EepRead((EEP_ADDR_CIRCLE_DATA +(temp*PACK_NUM_GPRS)), g_frame_temp_buf_GuangShui, 155, &s_eep_complete_GuangShui);		
				up_deal_stat_GuangShui  = UP_DEAL_S1;
			}
        }
        break;

        case UP_DEAL_S1:
        {
            if(TASK_IDLE == EepIfIdle())//ȡʷ
            {
				g_frame_temp_len_GuangShui = PACK_NUM_GPRS;  
                task_complete_GuangShui = PTL_PACK_SUCCESS;                
                up_deal_stat_GuangShui  = UP_DEAL_S0;
            }
        }
        break;
      
        default:
        {
            up_deal_stat_GuangShui  = UP_DEAL_S0;
            task_complete_GuangShui = PTL_PACK_FAIL;
        }
        break;
    }    	 
}

//ʧܴ
static void frame_func_s3_NB_ClearFailTimes(void)
{   
	static u8 temp_clear_buf[4];
	if(TASK_IDLE == EepIfIdle())
	{
		g_frame_temp_len_GuangShui = 0;
		NB_SS_Control_SetPara(NB_SS_FormatError, 0);
		NB_SS_Control_SetPara(NB_UploadFailTimes, 0);
		temp_clear_buf[0]=0;
		temp_clear_buf[1]=0;
		temp_clear_buf[2]=0;
		temp_clear_buf[3]=0;
		EepWrite(temp_clear_buf, FRAME_NBIot_BUBAO_FLAG, 4, &s_eep_complete_GuangShui);
		task_complete_GuangShui = PTL_PACK_SUCCESS;
	}
}
/*************************************ˮԼ*******************************************************/
/**
:gs_ack_upload_frame
˵:ϱݵӦ
 01ϱָ
ݶθʽ:
ƽ̨ǰʱ 6 ֽ BCD 룺 YYMMDDHHNNSS 2020-01-11 12:15:30 200111121530
*/

void gs_ack_upload_frame(void)
{
	DateTime rtcc_time_rcvjm;
	g_frame_temp_len_GuangShui = 0;
	
	RtccGetDateTime(&rtcc_time_gs);	//ȡǰʱ
	rtcc_time_rcvjm.s.second = *(new_message_data_rev_jm + 5);	//second
	rtcc_time_rcvjm.s.minute = *(new_message_data_rev_jm + 4);	//MIN
	rtcc_time_rcvjm.s.hour = *(new_message_data_rev_jm + 3);		//Hour
	rtcc_time_rcvjm.s.day = *(new_message_data_rev_jm + 2);		//day
	rtcc_time_rcvjm.s.month = *(new_message_data_rev_jm + 1);	//mon
	rtcc_time_rcvjm.s.year  = *(new_message_data_rev_jm );	//year
	long diff_time = 0;
	diff_time = RtccCalculateDiffTime(&rtcc_time_rcvjm, &rtcc_time_gs);
	if(diff_time < 0)
	{
		diff_time = 0 - diff_time;
	}
	if(diff_time < HOUR_TO_SECOND)	//1hڵӦжΪЧ
	{
		FrameSetMsgApp(MsgNbUplaod_AckOk);
	}	
	
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= rtcc_time_gs.s.year;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= rtcc_time_gs.s.month;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= rtcc_time_gs.s.day;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= rtcc_time_gs.s.hour;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= rtcc_time_gs.s.minute;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= rtcc_time_gs.s.second;
	
	up_deal_stat_GuangShui  = UP_DEAL_S0;
	task_complete_GuangShui = PTL_PACK_FAIL;
}


/**
:gs_read_history_frame
˵:豸ѯĳһʱڵʷݻ ʵʱ
ݸʽ: 
    ָʶ:2ֽڸ; ֽǰ,豸Ӧԭ뷵ظֵ
    ʼʱ:6ֽBCD, 200111121530 (ʼʱȫΪ0ʱ,豸ڴʵʱݣϱݶеʱΪ豸ǰʱ)
    ʱθ:1ֽ
    ʱ:2ֽ,ֽǰ
ݸʽ:
    ָʶ:ִָʧ MID ȫֽ FFҲϷ 
    ʼʱ:
    ʱθ:
    ʱ:
    1,2... ...:
*/
static void gs_read_history_frame(void)
{
	switch(up_deal_stat_GuangShui)
	{
		case UP_DEAL_S0:
		{
			g_frame_temp_len_GuangShui =11;//ݿʼλ
			RtccGetDateTime(&rtcc_time_gs);
			//ʼʱ
			his_read_start_time.s.year=new_message_data_rev_jm[2];
			his_read_start_time.s.month=new_message_data_rev_jm[3];
			his_read_start_time.s.day=new_message_data_rev_jm[4];
			his_read_start_time.s.hour=new_message_data_rev_jm[5]; 
			his_read_start_time.s.minute=new_message_data_rev_jm[6]; 
			his_read_start_time.s.second=new_message_data_rev_jm[7]; 			
			//ʱθ
			his_read_count=new_message_data_rev_jm[8]; 
			//ʱ
			his_read_period.data_buf[0]=new_message_data_rev_jm[10];        
			his_read_period.data_buf[1]=new_message_data_rev_jm[9];
			
			//жʱǷЧ
			if(his_read_period.datas != his_save_para.Data.Period.datas)
			{
				//쳣
				up_deal_stat_GuangShui = UP_DEAL_S4;
			}
			else
			{
				//жʼʱǷЧ
				temp_diff_time = RtccCalculateDiffTime(&rtcc_time_gs, &his_read_start_time);
				if((temp_diff_time < (his_save_para.Data.Index_w.datas*his_save_para.Data.Period.datas*60))&&(temp_diff_time<(GS_HIS_STORE_MAX*his_save_para.Data.Period.datas*60)))
				{
					//жʱǷЧ
					if((his_read_count*his_save_para.Data.Period.datas*60)<temp_diff_time)
					{
						his_read_end_count = 0;
						his_read_start_count = his_save_para.Data.Index_w.datas - (temp_diff_time/60)/his_save_para.Data.Period.datas;
						up_deal_stat_GuangShui = UP_DEAL_S1;
					}
					else//쳣
					{
						up_deal_stat_GuangShui = UP_DEAL_S4;
					}
				}
				else//쳣
				{
					up_deal_stat_GuangShui = UP_DEAL_S4;
				}
			}
		}
		break;
		case UP_DEAL_S1://ݶȡ
		{
			if(TASK_IDLE == EepIfIdle())
			{
				his_read_addr = EEP_ADDR_HIS_DATA+(((his_read_start_count+his_read_end_count)%GS_HIS_STORE_MAX)*5);
				EepRead(his_read_addr, &his_read_flow_buf[0], 5, &s_eep_complete_GuangShui);
				up_deal_stat_GuangShui = UP_DEAL_S2;
			}
		}
		break;
		case UP_DEAL_S2://ݴ:EE_BUF->FLOW_BUF->FLOW_FLOAT->FLOW_U8BUF->BCD
		{
			if(TASK_IDLE == EepIfIdle())
			{
				his_read_check = his_read_flow_buf[0]+his_read_flow_buf[1]+his_read_flow_buf[2]+his_read_flow_buf[3];
				if(his_read_flow_buf[4] == his_read_check)
				{
					his_read_new_flow.buf[0] = his_read_flow_buf[0];
					his_read_new_flow.buf[1] = his_read_flow_buf[1];
					his_read_new_flow.buf[2] = his_read_flow_buf[2];
					his_read_new_flow.buf[3] = his_read_flow_buf[3];
					if(his_read_end_count==0)
					{
						his_read_tempData.datas = (u32)(his_read_new_flow.gp22_float*10);
						u32HEXtoBCDData(his_read_tempData.datas, &his_read_tempBuf[0]);
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= 0x20;
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= his_read_tempBuf[5];
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= his_read_tempBuf[4];
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= his_read_tempBuf[3];
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= his_read_tempBuf[2];
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= his_read_tempBuf[1];
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= his_read_tempBuf[0];
						//
						his_read_old_flow.gp22_float = his_read_new_flow.gp22_float;
					}
					else
					{
						his_read_tempData.datas = (u16)((his_read_new_flow.gp22_float - his_read_old_flow.gp22_float)*10);
						u32HEXtoBCDData(his_read_tempData.datas, &his_read_tempBuf[0]);
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= his_read_tempBuf[2];
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= his_read_tempBuf[1];
						g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= his_read_tempBuf[0];
						//
						his_read_old_flow.gp22_float = his_read_new_flow.gp22_float;
					}
					if((his_read_end_count < (his_read_count-1))&&(his_read_end_count<47))//һ
					{
						his_read_end_count++;
						up_deal_stat_GuangShui = UP_DEAL_S1;
					}
					else//ȡ
					{
						up_deal_stat_GuangShui  = UP_DEAL_S3;
					}
				}
				else//󷵻
				{
					if(his_read_end_count == 0)//쳣
					{
						up_deal_stat_GuangShui = UP_DEAL_S4;
					}
					else
					{
						up_deal_stat_GuangShui = UP_DEAL_S3;
					}
				}
			}
		}
		break;
		case UP_DEAL_S3:
		{
			//MID
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
			//Ӧ:ʼʱ
			g_frame_temp_buf_GuangShui[2]=his_read_start_time.s.year;
			g_frame_temp_buf_GuangShui[3]=his_read_start_time.s.month;
			g_frame_temp_buf_GuangShui[4]=his_read_start_time.s.day;
			g_frame_temp_buf_GuangShui[5]=his_read_start_time.s.hour;
			g_frame_temp_buf_GuangShui[6]=his_read_start_time.s.minute;
			g_frame_temp_buf_GuangShui[7]=his_read_start_time.s.second;
			//Ӧ:ʱθ
			g_frame_temp_buf_GuangShui[8]=his_read_end_count;//ʵʶȡĸ
			//Ӧ:ʱ
			g_frame_temp_buf_GuangShui[9]=his_read_period.data_buf[1];
			g_frame_temp_buf_GuangShui[10]=his_read_period.data_buf[0];
			
			up_deal_stat_GuangShui  = UP_DEAL_S0;
			task_complete_GuangShui = PTL_PACK_SUCCESS;
		}
		break;
		case UP_DEAL_S4://쳣
		{
			//ִָʧ MID ȫֽ FFҲϷݶ
			//MID
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
			//Ӧ:ʼʱ
			g_frame_temp_buf_GuangShui[2]=0xFF;
			g_frame_temp_buf_GuangShui[3]=0xFF;
			g_frame_temp_buf_GuangShui[4]=0xFF;
			g_frame_temp_buf_GuangShui[5]=0xFF;
			g_frame_temp_buf_GuangShui[6]=0xFF;
			g_frame_temp_buf_GuangShui[7]=0xFF;
			//Ӧ:ʱθ
			g_frame_temp_buf_GuangShui[8]=0xFF;
			//Ӧ:ʱ
			g_frame_temp_buf_GuangShui[9]=0xFF;
			g_frame_temp_buf_GuangShui[10]=0xFF;
			
			up_deal_stat_GuangShui  = UP_DEAL_S0;
			task_complete_GuangShui = PTL_PACK_SUCCESS;
		}
		break;
		default:
		{
			up_deal_stat_GuangShui = UP_DEAL_S0;
		}
		break;
	}
}
//նʱ
void jm_set_time()
{
	switch(up_deal_stat_GuangShui)
	{
		case UP_DEAL_S0:
		{
			g_frame_temp_len_GuangShui = 0;
			rtcc_time_gs.s.year  = *(new_message_data_rev_jm + 2);
			rtcc_time_gs.s.month = *(new_message_data_rev_jm + 3);
			rtcc_time_gs.s.day   = *(new_message_data_rev_jm + 4);
			rtcc_time_gs.s.hour  = *(new_message_data_rev_jm + 5);
			rtcc_time_gs.s.minute= *(new_message_data_rev_jm + 6);
			rtcc_time_gs.s.second= *(new_message_data_rev_jm + 7);
			if(SUCCESS_IES == Rtcc_Check_DateTime(&rtcc_time_gs))//ںϷ
			{
				RtccSetDateTime(&rtcc_time_gs);
				up_deal_stat_GuangShui  = UP_DEAL_S1;
			}
			else
			{
				up_deal_stat_GuangShui  = UP_DEAL_S2;
			}
		}
		break;
		case UP_DEAL_S1:
		{
			RtccGetDateTime(&rtcc_time_gs);//ȡǰʱ	
			//MID
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
			//time
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = rtcc_time_gs.s.year;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = rtcc_time_gs.s.month; 
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = rtcc_time_gs.s.day;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = rtcc_time_gs.s.hour;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = rtcc_time_gs.s.minute;					
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = rtcc_time_gs.s.second;
			up_deal_stat_GuangShui  = UP_DEAL_S0;
			task_complete_GuangShui = PTL_PACK_SUCCESS;
		}
		break;
		case UP_DEAL_S2:
		{
			//MID
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
			//time
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF; 
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;					
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
			up_deal_stat_GuangShui  = UP_DEAL_S0;
			task_complete_GuangShui = PTL_PACK_SUCCESS;
		}
		break;
		default:
		{
			up_deal_stat_GuangShui  = UP_DEAL_S0;
			task_complete_GuangShui = PTL_PACK_FAIL;
		}
		break;
	}
}
//ʷݴ̼
void jm_set_save_interval()
{
	if (TASK_IDLE == EepIfIdle()) 
	{
		g_frame_temp_len_GuangShui =0;
		//MID
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
		//
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = *(new_message_data_rev_jm + 2);
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = *(new_message_data_rev_jm + 3);
		

		his_save_para.Data.Period.data_buf[1]=*(new_message_data_rev_jm + 2);     
		his_save_para.Data.Period.data_buf[0]=*(new_message_data_rev_jm + 3);
		
		EepWrite(&his_save_para.data_buf[0], EEP_ADDR_HIS_INDEX, 6, &s_eep_complete_GuangShui);	
		
		up_deal_stat_GuangShui  = UP_DEAL_S0;
		task_complete_GuangShui = PTL_PACK_SUCCESS;	
	}
}
//ϱ
void jm_up_set() 
{
	if (TASK_IDLE == EepIfIdle())
	{
		g_frame_temp_len_GuangShui =0;
		//MID
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
		//ʼʱ
		linshi_jm.Data.start_time_h = *(new_message_data_rev_jm+2);          
		linshi_jm.Data.start_time_m=*(new_message_data_rev_jm+3);
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = *(new_message_data_rev_jm + 2);
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = *(new_message_data_rev_jm + 3);
		//Ϸ
		linshi_jm.Data.up_interval.data_buf[1]=*(new_message_data_rev_jm+4);  ////Ϸ
		linshi_jm.Data.up_interval.data_buf[0]=*(new_message_data_rev_jm+5);			
		if(linshi_jm.Data.up_interval.datas <=60) //ʱϱ1Сʱ
		{
			linshi_jm.Data.up_interval.datas = 60;
		}
		else if(linshi_jm.Data.up_interval.datas >= 60*24) //ʱϱ24
		{
			linshi_jm.Data.up_interval.datas =60*24;				
		}	
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = linshi_jm.Data.up_interval.data_buf[1];
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = linshi_jm.Data.up_interval.data_buf[0];
		//ݼ
		linshi_jm.Data.data_interval.data_buf[1]=*(new_message_data_rev_jm+6);
		linshi_jm.Data.data_interval.data_buf[0]=*(new_message_data_rev_jm+7);
		if(linshi_jm.Data.data_interval.datas<=5) //ʱ洢5
		{
			linshi_jm.Data.data_interval.datas=5;
		}
		else if(linshi_jm.Data.data_interval.datas>=60*12)
		{
			linshi_jm.Data.data_interval.datas=60*12;
		}	
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = linshi_jm.Data.data_interval.data_buf[1];
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = linshi_jm.Data.data_interval.data_buf[0];
		//ɢֵ
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0;
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0;
		//Чʱ
		linshi_jm.Data.effective_time.data_buf[1]=*(new_message_data_rev_jm+10); 
		linshi_jm.Data.effective_time.data_buf[0]=*(new_message_data_rev_jm+11);
		if(linshi_jm.Data.effective_time.datas >=24*60)
		{
			linshi_jm.Data.effective_time.datas =24*60;
		}
		if(linshi_jm.Data.effective_time.datas==0)
		{
			linshi_jm.Data.effective_time.datas=24*60;		
		}
		RtccGetDateTime(&rtcc_linshi_jm);				//ЧʱֱӸֵǰʱ
		rtcc_linshi_jm.s.hour = linshi_jm.Data.start_time_h;
		rtcc_linshi_jm.s.minute = linshi_jm.Data.start_time_m;
		
		EepWrite(&linshi_jm.data_buf[0], EEP_ADDR_TEMP_STORE_UPLOAD, 8, &s_eep_complete_GuangShui);	 
		
		linshi_data_eff=1;//ʱ洢ϱ־
		ls_save_cnt=0;//ϱ0
		ls_upload_index=0;//ʱϱָ
		up_deal_stat_GuangShui  = UP_DEAL_S0;
		task_complete_GuangShui = PTL_PACK_SUCCESS;	
	}			
}

//ȡʱݴ洢ϱ
void jm_Up_read() 
{
    g_frame_temp_len_GuangShui =0;
	//MID
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
    g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= linshi_jm.Data.start_time_h;
    g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= linshi_jm.Data.start_time_m;
    g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= linshi_jm.Data.up_interval.data_buf[1];
    g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= linshi_jm.Data.up_interval.data_buf[0];
    g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= linshi_jm.Data.data_interval.data_buf[1];
    g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= linshi_jm.Data.data_interval.data_buf[0];
    g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= 0;
    g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++]= 0;
	up_deal_stat_GuangShui  = UP_DEAL_S0;
	task_complete_GuangShui = PTL_PACK_SUCCESS;	
}

//жʱ洢ʱϱ
u8 get_lset_judg(u8*save,u8*up)  //жǷִʱ
{
	long 	diff_time;
	static u32 time_min;	
	
	RtccGetDateTime(&rtcc_time_gs);
	diff_time = RtccCalculateDiffTime(&rtcc_time_gs,&rtcc_linshi_jm)/(60); //ʱ	
	if(diff_time>24*60)
	{
		linshi_data_eff=0;
	}
	if((diff_time <linshi_jm.Data.effective_time.datas)&&linshi_data_eff&&(diff_time>0))
	{   
		time_min= ((rtcc_time_gs.s.hour >> 4) * 10 + (rtcc_time_gs.s.hour & 0x0F))*60;
		time_min+= (rtcc_time_gs.s.minute >> 4) * 10 + (rtcc_time_gs.s.minute & 0x0F);
		if(linshi_jm.Data.up_interval.datas<24*60)
		{
			if((time_min%linshi_jm.Data.up_interval.datas)==0)
			{
				*up=TRUE;
			}
			else
			{
				*up=FALSE;
			}
		}
		else
		{
			*up=FALSE;
		}			
		if(time_min%linshi_jm.Data.data_interval.datas==0)
		{
			*save=TRUE;
		}
		else
		{
			*save=FALSE;
		}	
		return TRUE;
	}
	else 
	{		  
		*save=FALSE;
		*up=FALSE;
		return FALSE;
	}
}
//ĵַ
void jm_set_center_add()
{
	static u16 add_len;
	u16 num_ip=0;
	u8 *mack[5];
	if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
	{
		g_frame_temp_len_GuangShui =0;
		//MID
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
		
		add_len=frame_struct_JM.data_len.to_uint16-15-2; //·ܳȥmid
		for(u8 l=2; l<add_len; l++)
		{
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = *(new_message_data_rev_jm+l);
			if(((char)(*(new_message_data_rev_jm+l))==':'))
			{
				*(new_message_data_rev_jm+l)='.';
			}
			if(((char)(*(new_message_data_rev_jm+l))=='.')&&(num_ip<=3))
			{
				mack[0]=new_message_data_rev_jm+1;
				mack[++num_ip]=(new_message_data_rev_jm+l);
				if(num_ip==4)
				{
					for(u8 n=0; n<4; n++)
					{
						if(mack[n+1]-mack[n]==2)
						{
							Sys_data_object.P1.server_ip[n]=*(mack[n]+1)-0x30;
						}
						else if(mack[n+1]-mack[n]==3)
						{
							Sys_data_object.P1.server_ip[n]=(*(mack[n]+1)-0x30)*10+(*(mack[n]+2)-0x30);
						}
						else if(mack[n+1]-mack[n]==4)
						{
							Sys_data_object.P1.server_ip[n]=(*(mack[n]+1)-0x30)*100+(*(mack[n]+2)-0x30)*10+(*(mack[n]+3)-0x30);
						}
					}
					if(new_message_data_rev_jm+2+add_len-mack[4]==3)	    //port	Ϊ1λ  0λ
					{
						Sys_data_object.P1.server_port.datas=*(mack[4]+1)-0x30;
					}
					else if(new_message_data_rev_jm+2+add_len-mack[4]==4)	//port	Ϊλ
					{
						Sys_data_object.P1.server_port.datas=(*(mack[4]+1)-0x30)*10+*(mack[4]+2)-0x30;
					}
					else if(new_message_data_rev_jm+2+add_len-mack[4]==5)	//port	Ϊ3λ
					{
						Sys_data_object.P1.server_port.datas=(*(mack[4]+1)-0x30)*100+(*(mack[4]+2)-0x30)*10+(*(mack[4]+3)-0x30);
					}
					else if(new_message_data_rev_jm+2+add_len-mack[4]==6)	//port	Ϊ4λ
					{
						Sys_data_object.P1.server_port.datas=(*(mack[4]+1)-0x30)*1000+(*(mack[4]+2)-0x30)*100+(*(mack[4]+3)-0x30)*10+(*(mack[4]+4)-0x30);
					}
					else if(new_message_data_rev_jm+2+add_len-mack[4]==7)	//port	Ϊ5λ
					{
						Sys_data_object.P1.server_port.datas=(*(mack[4]+1)-0x30)*10000
						+(*(mack[4]+2)-0x30)*1000+(*(mack[4]+3)-0x30)*100+(*(mack[4]+4)-0x30)*10+(*(mack[4]+5)-0x30);
					}
				}
			}
		}
		EepWrite(&Sys_data_object.P1.server_ip[0], FRAME_NBIot_IP, 6, &s_eep_complete_GuangShui);
		up_deal_stat_GuangShui  = UP_DEAL_S0;
		task_complete_GuangShui = PTL_PACK_SUCCESS;
	}
}
//ùģʽ,ֻ֡,ʵӦ
void jm_set_mode()   
{
	g_frame_temp_len_GuangShui =0;
	//MID
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
	//ģʽЧʱ
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0x00;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0x00;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0x00;
	up_deal_stat_GuangShui  = UP_DEAL_S0;
	task_complete_GuangShui = PTL_PACK_SUCCESS;
}
//豸ַ,(豸ַָڷ NB ˮӦóNB ˮͨ ģ NB ˮʵָָ)
void jm_set_add_frame()  //֡
{
	g_frame_temp_len_GuangShui =0;
	//MID
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
	//豸ַ
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0xFF;
	up_deal_stat_GuangShui  = UP_DEAL_S0;
	task_complete_GuangShui = PTL_PACK_SUCCESS;
}
//üܱ־,Ч
void jm_encrypted_data_frame()
{
    g_frame_temp_len_GuangShui =0;
	//MID
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
	//ܱ־Կ
	for(int i=0;i<17;i++)
	{
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = *(new_message_data_rev_jm+2+i);
	}
	up_deal_stat_GuangShui  = UP_DEAL_S0;
	task_complete_GuangShui = PTL_PACK_SUCCESS;
}
//ѯʷݴ̼
void jm_read_interval_frame()
{
	g_frame_temp_len_GuangShui =0;
	//MID
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
	//
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = his_save_para.Data.Period.data_buf[1];
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = his_save_para.Data.Period.data_buf[0];

	up_deal_stat_GuangShui  = UP_DEAL_S0;
	task_complete_GuangShui = PTL_PACK_SUCCESS;
}
//ѯĵַ
void jm_read_add_frame()
{
	g_frame_temp_len_GuangShui =0;
	//MID
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI0;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = frame_struct_GuangShui.DI1;
	for (int i = 0; i < 4; i++)
	{
		if (Sys_data_object.P1.server_ip[i] < 10)
		{
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = Sys_data_object.P1.server_ip[i] + 0x30;
		}
		else if (Sys_data_object.P1.server_ip[i] < 100)
		{
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_ip[i] / 10) + 0x30;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_ip[i] % 10) + 0x30;
		}
		else
		{
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_ip[i] / 100) + 0x30;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_ip[i] / 10) % 10 + 0x30;
			g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_ip[i] % 10) + 0x30;
		}
		g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = '.';
	}
	g_frame_temp_len_GuangShui--;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = ':';
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_port.datas / 10000) + 0x30;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_port.datas % 10000) / 1000 + 0x30;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_port.datas % 1000) / 100 + 0x30;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_port.datas % 100) / 10 + 0x30;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = (Sys_data_object.P1.server_port.datas % 10) + 0x30;
	g_frame_temp_buf_GuangShui[g_frame_temp_len_GuangShui++] = 0x0;
	
	up_deal_stat_GuangShui  = UP_DEAL_S0;
	task_complete_GuangShui = PTL_PACK_SUCCESS;
}
/****************************************************************************************************/
//ˮԼ
u8 crack_frame_GS(u16 frame_lenth,u8 *frame_buffer)
{
    u16 i;
    u16 j;
    u16 endloc = 0;
    u16 framelen = 0;
    if (frame_lenth > FRAME_LEN_MAX) //֡Ƿݻ
    {
        return (ERROR_IES);
    }
    if (frame_lenth < FRAME_LEN_MIN) //֡ǷССЭ֡
    {
        return (ERROR_IES);
    }
    for (i = 0; i < frame_lenth; i++)
    {
        if (FRAME_HEAD_JM == *frame_buffer) //ҵ֡ͷ
        {
            frame_struct_JM.locn = i;									//ס֡ͷReceive_bufλ
            frame_struct_JM.len.to_uint8[1] = *(frame_buffer + 1); 	//
            frame_struct_JM.len.to_uint8[0] = *(frame_buffer + 2);

            framelen = frame_struct_JM.len.to_uint16+2; 				//֡ ·Ĳͷβ
            if (frame_struct_JM.len.to_uint16 > (frame_lenth - i))		//ֹͨѶԼǡƹԽ縴λ
            {
                return (ERROR_IES);
            }
            endloc = framelen - 1;
						
            if ((FRAME_END_JM == frame_buffer[endloc]) && (endloc <= frame_lenth)) 		//ȷ֡Ч
            {
                frame_struct_JM.crc = 0;
                for (j = 0; j < (framelen - 2); j++)
                {
                    frame_struct_JM.crc = (u8)(frame_struct_JM.crc + frame_buffer[j]); //У
                }
                if (frame_struct_JM.crc == frame_buffer[endloc - 1])   //jУͨ
                {
                    frame_struct_JM.frame_ctrl = *(frame_buffer + 13);  				//ȡ
                    if((*(frame_buffer + 3) & 0x40)	)//   ֡ʶУҪжϴλ
                    {
                    }
                    else
                    {
                        frame_struct_JM.data_len.to_uint8[1] = *(frame_buffer + 1);		//򳤶
                        frame_struct_JM.data_len.to_uint8[0] = *(frame_buffer + 2);
                       /* for (j = 0; j < (frame_struct_JM.data_len.to_uint16-15); j++)//»
                        {
                            jm_rcv_buf[j] = *(frame_buffer + 15 + j);
                        }*/
                        new_message_data_rev_jm = frame_buffer + frame_struct_JM.locn + 15;	
						
						frame_struct_GuangShui.ctrl = frame_struct_JM.frame_ctrl;
						frame_struct_GuangShui.DI0 = *(new_message_data_rev_jm + 0);//MID
						frame_struct_GuangShui.DI1 = *(new_message_data_rev_jm + 1);//MID
                    }
                    return (SUCCESS_IES);
                }
            }
        }
        frame_buffer++;
    }
    return (ERROR_IES);
}
//ˮԼ
u8 crack_frame_GuangShui(u16 frame_lenth,u8 *frame_buffer)
{
	u8 temp_res = crack_frame_IES_Base(frame_lenth, frame_buffer, &frame_struct_GuangShui);
	if(temp_res == SUCCESS_IES)
	{		
		new_message_data_rev_GuangShui = frame_buffer + frame_struct_GuangShui.head_site + 16;								
		return  SUCCESS_IES;
	}
	else if(crack_frame_GS(frame_lenth, frame_buffer) == SUCCESS_IES)//ˮԼ
	{
		return  SUCCESS_IES;
	}
	return ERROR_IES;
}

//ˮԼ
u8 up_deal_code_GuangShui(void)
{
    task_complete_GuangShui = PTL_PACK_BUSY;
    switch(frame_struct_GuangShui.ctrl)
    {
		case SS_CLEAR_FAIL_TIMES_CTRL:
		{
			frame_func_s3_NB_ClearFailTimes();
			frame_struct_GuangShui.ack_ctrl = SS_ACK_CLEAR_FAIL_TIMES_CTRL;
		}
		break;
		case SS_READ_HIS_CTRL:
		{
			switch(frame_struct_GuangShui.DI1)
			{
				case SS_READ_HIS_CTRL_ID1://ˮԼʷ
				{
					frame_func_reply_NB_ReadHistoryData();
					frame_struct_GuangShui.ack_ctrl = SS_ACK_READ_HIS_CTRL;
				}
				break;
				default:
				{
					up_deal_stat_GuangShui  = UP_DEAL_S0;
					task_complete_GuangShui = PTL_PACK_FAIL; 
				}
			}
		}
		break; 
		//ˮԼ
		case READ_MET_CTRL_01: 	//ظ
		{					
			gs_ack_upload_frame();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_01;
		}	
		break;	
		
		case READ_MET_CTRL_03: 	//ظ
		{
			gs_ack_upload_frame();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_03;
		}	
		break;
		
		case READ_MET_CTRL_02: 	//ݲѯ
		{
			gs_read_history_frame();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_02;
		}
		break;

		case READ_MET_CTRL_04:  //ʱ
		{
			jm_set_time();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_04;
		}
		break;

		case READ_MET_CTRL_05: 	//ʷ̼
		{
			jm_set_save_interval();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_05;
		}
		break;

		case READ_MET_CTRL_06:  //ϱ
		{
			jm_up_set();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_06;
		}
		break;

		case READ_MET_CTRL_07:		//ĵַ
		{
			jm_set_center_add();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_07;
		}
		break;

		case READ_MET_CTRL_08:	//ģʽ
		{
			jm_set_mode();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_08;
		}
		break;

		case READ_MET_CTRL_09:			//豸ַ
		{
			jm_set_add_frame();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_09;
		}
		break;

		case READ_MET_CTRL_010:		//üܱ־
		{
			jm_encrypted_data_frame();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_010;
		}
		break;

		case READ_MET_CTRL_011:		//ѯʷ̼
		{
			jm_read_interval_frame();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_011;
		}
		break;
		
		case READ_MET_CTRL_012:		//ѯϱ
		{
			jm_Up_read();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_012;
		}
		break;
		
		case READ_MET_CTRL_013:		//ѯĵַ
		{
			jm_read_add_frame();
			frame_struct_GuangShui.ack_ctrl = READ_MET_CTRL_013;
		}
		break;
        default:
        {     
			up_deal_stat_GuangShui  = UP_DEAL_S0;
			task_complete_GuangShui = PTL_PACK_FAIL;           
        }
        break;
    }
    return task_complete_GuangShui;
}

void Frame_ResetDealState_GuangShui(void)
{
	up_deal_stat_GuangShui = UP_DEAL_S0;//չԼ״̬λ
}

void Frame_ack_GS(STRUCT_FRAME_IES temp_struct, u8* p_temp_buf, u16 p_temp_len, u8* p_send_buf, u16* p_send_len)
{
    int i = 0;
	int temp_pack_len;
	UNION_2U8TOU16 temp_data;
	MEASURE_UPLOAD_INFO  temp_UploadInfo;
	u8 temp_buf1[24];
	u8 temp_buf2[24];
	u32 temp_cell_id=0;
	
	temp_pack_len = 0;
    p_send_buf[temp_pack_len++] = FRAME_HEAD_JM;//֡ʼ69H
    p_send_buf[temp_pack_len++] = ((48+p_temp_len)>>8);//֡ ֽǰ
    p_send_buf[temp_pack_len++] = (48+p_temp_len)&0xFF;
    p_send_buf[temp_pack_len++] = FRAME_MARK_JM;//֡ʶ Ƿ 1bitǷ֡ 2bit֡ 4bit Ƿв 1bit
	p_send_buf[temp_pack_len++] = FRAME_TYPE_JM;//Э汾  汾 4bitӰ汾 4bit
	//豸ַ 8Byte
	p_send_buf[temp_pack_len++] = 0x79;
	for (i = 0; i < 7; i++)
	{
		p_send_buf[temp_pack_len++] = Sys_data_object.P1.met_addr[i];
	}
    p_send_buf[temp_pack_len++] = temp_struct.ack_ctrl; //
	p_send_buf[temp_pack_len++] = FRAME_HEAD_JM;//֡ȷϷ69H
	/////////////////////////в///////////////////////////////
	//豸ʶ,ģʽСھˮ
	p_send_buf[temp_pack_len++] =0x03;
	//豸ѹ 02H E8H = 744 * 0.01 =7.44V
	temp_data.datas = PowerCheckValueSys();
	p_send_buf[temp_pack_len++] = temp_data.data_buf[1];
	p_send_buf[temp_pack_len++] = temp_data.data_buf[0];
	//źǿ CSQ
	temp_UploadInfo = UploadGetInfo_Base();
	p_send_buf[temp_pack_len++] = temp_UploadInfo.metinfo.single_val;
	//չʣRSRP 2 ֽɣֽǰֽں
	temp_UploadInfo.metinfo.RSRP_val /=10;
	temp_UploadInfo.metinfo.RSRP_val =~temp_UploadInfo.metinfo.RSRP_val+1;
	p_send_buf[temp_pack_len++] = (temp_UploadInfo.metinfo.RSRP_val)>>8;
	p_send_buf[temp_pack_len++] = (temp_UploadInfo.metinfo.RSRP_val);
	//  2 ֽɣֽǰֽں
	if(temp_UploadInfo.metinfo.snr_val>=0x8000)
	{
		temp_UploadInfo.metinfo.snr_val -= 0x8000;
		temp_UploadInfo.metinfo.snr_val /= 10;
		temp_UploadInfo.metinfo.snr_val = ~temp_UploadInfo.metinfo.snr_val+1;
	}
	else
	{
		temp_UploadInfo.metinfo.snr_val /= 10;
	}
	p_send_buf[temp_pack_len++] = temp_UploadInfo.metinfo.snr_val>>8;
	p_send_buf[temp_pack_len++] = temp_UploadInfo.metinfo.snr_val;
	//ǵȼ
	p_send_buf[temp_pack_len++] = temp_UploadInfo.metinfo.ecl_val;
	//С ID  4Byte
	NbiotGetCell_ID(temp_buf1);
	for(i=0;i<CELL_ID_SIZE;i++)
	{
	    if(temp_buf1[i] != 0)
		{
			temp_cell_id <<= 4;
			if(temp_buf1[i] <= '9')
			{
			    temp_cell_id |= temp_buf1[i]-'0';
			}
			else if((temp_buf1[i] <= 'f')&&(temp_buf1[i] >= 'a'))
			{
			    temp_cell_id |= temp_buf1[i]-'a'+10;
			}
			else if((temp_buf1[i] <= 'F')&&(temp_buf1[i] >= 'A'))
			{
			    temp_cell_id |= temp_buf1[i]-'A'+10;
			}
		}
	}
	p_send_buf[temp_pack_len++] = temp_cell_id>>24;
	p_send_buf[temp_pack_len++] = temp_cell_id>>16;
	p_send_buf[temp_pack_len++] = temp_cell_id>>8;
	p_send_buf[temp_pack_len++] = temp_cell_id>>0;
	//IMEI ʶ  8Byte BCD
	NbiotGetIMEI((char*)temp_buf1); 
	temp_buf2[0] = temp_buf1[0] - 0x30;
	for(i=1;i<8;i++)
	{
		temp_buf2[i]  =  (temp_buf1[2*i]-0x30)&0x0F;
		temp_buf2[i] |= ((temp_buf1[2*i-1]-0x30)<<4)&0xF0;          
	}
	for(i=0;i<8;i++)
	{
	    p_send_buf[temp_pack_len++] = temp_buf2[i];
	}
	//SIM ʶ 10Byte BCD
	NbiotGetICCID((char*)temp_buf1); 
	for(i=0;i<10;i++)
	{
	    p_send_buf[temp_pack_len++] = ((temp_buf1[i*2]-0x30)<<4)|(temp_buf1[2*i+1]-0x30);
	}
	/////////////////////////ݶ  ///////////////////////////////
	for(i=0;i<p_temp_len;i++)
	{
	    p_send_buf[temp_pack_len++] = p_temp_buf[i];
	}
	//У
	p_send_buf[temp_pack_len] = 0;//У0
	for(i = 0; i < temp_pack_len; i++) //Ҫ´0ʼ///////
    {
        p_send_buf[temp_pack_len] += p_send_buf[i];
    }
    temp_pack_len++;
    p_send_buf[temp_pack_len++] = FRAME_END_JM;	//֡β
	*p_send_len = temp_pack_len;
}
//Ӧ֡
void Frame_ack_GuangShui(u8* p_send_buf, u16* p_send_len)
{
	STRUCT_FRAME_IES temp_struct;
	
	temp_struct.ack_ctrl = frame_struct_GuangShui.ack_ctrl;
	temp_struct.DI0 = frame_struct_GuangShui.DI0;
	temp_struct.DI1 = frame_struct_GuangShui.DI1;
	switch(temp_struct.ack_ctrl)
	{
		case SS_ACK_CLEAR_FAIL_TIMES_CTRL:
		case SS_ACK_READ_HIS_CTRL:
		{
			temp_struct.sta = frame_struct_GuangShui.sta;
			temp_struct.serial_num0 = frame_struct_GuangShui.serial_num0;
			temp_struct.serial_num1 = frame_struct_GuangShui.serial_num1;

			Frame_ack_IesBase(temp_struct,g_frame_temp_buf_GuangShui, g_frame_temp_len_GuangShui, p_send_buf, p_send_len);
		}
		break;
		default://ˮԼ
		{
			Frame_ack_GS(temp_struct,g_frame_temp_buf_GuangShui, g_frame_temp_len_GuangShui, p_send_buf, p_send_len);
		}
	}
}
/****************************************************************ϱݵĴ*********************************************/
static void setStoreMsg(SS_StoreMsgType msg, boolean_t bFlag)
{
    if(TRUE == bFlag)
    {
        temp_store_msg |= (1<<msg);
    }
    else
    {
        temp_store_msg &= (~(1<<msg));
    }    
}

static boolean_t getStoreMsg(SS_StoreMsgType msg)
{
	if(temp_store_msg & (1<<msg))
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

//ݰеĵǰϢ״̬
static void Upload_RenewCurrentData(STRU_UPLOAD_FRAME* temp_frame)
{
	MET_STATE temp_state; //״̬
	u8 temp1 = 0;
	Fram_To_Float tmp_float;
	u8* hight_flow; 
	DateTime tempRtcc_time;

	tmp_float.gp22_u32  = Gp30CheckDataApp(2);
	temp_frame->data.CurrentFlow.datas = (u32)(tmp_float.gp22_float*10);//ǰۼ
	temp_frame->data.CurrentFlowForward.datas = temp_frame->data.CurrentFlow.datas;//ǰۼ
	tmp_float.gp22_u32 = Gp30CheckDataApp(3);//ǰۻ
	temp_frame->data.CurrentFlowReverse.datas = (u32)(tmp_float.gp22_float*10);
	//ȡ:(4ֽ),ʱ(2ֽ),ʼʱ(8ֽ,Ԥ)	
	RtccCheck_Hight_Flow(&hight_flow);			
	for(temp1 = 0; temp1 <14 ;temp1++)
	{
		temp_frame->data.DailyHighestFlowAndTime[temp1] = *(hight_flow+temp1);
	}
	//ȡ:rsrp(2B),صѹ(2B),(2B),źŸǵȼecl(2B),CSQ(1B),ѹֵ(1B)
	temp_frame->data.UploadInfo = UploadGetInfo_Base();
	//ȡ:2B()X2(/h)X24h=96B
	/*
	ϱʱͨUPLOAD_DATA_READ_HISȡ0洢ʱͨUPLOAD_DATA_STEP_FLOWȡ
	*/
	//ϱʱ
	RtccGetDateTime(&tempRtcc_time);//ϱʱ
	temp_frame->data.UploadTime[0] = tempRtcc_time.s.second;
	temp_frame->data.UploadTime[1] = tempRtcc_time.s.minute;
	temp_frame->data.UploadTime[2] = tempRtcc_time.s.hour;
	temp_frame->data.UploadTime[3] = tempRtcc_time.s.day;
	temp_frame->data.UploadTime[4] = tempRtcc_time.s.month;
	temp_frame->data.UploadTime[5] = tempRtcc_time.s.year; 
	temp_frame->data.UploadTime[6] = 0x20;
	//״̬
	temp_state = FrameGetByte();
	temp_frame->data.StateBytes[0] = temp_state.stat0;
	temp_frame->data.StateBytes[1] = temp_state.stat1;
	temp_frame->data.StateBytes[2] = temp_state.stat2;
	temp_frame->data.StateBytes[3] = temp_state.stat3;
	temp_frame->data.StateBytes[4] = temp_state.stat4;
	//ۼƻԾʱ
	temp_frame->data.DailyActiveTime.datas = GetEventUploadType();//ϱ
}


//ʷ֡
static void UploadData_GS(void)
{
	SS_UNION_4U8TOU32 tempData;
	u8 temp_buf[6];
	//ʼʱ
	upload_frame_gs.data.Datetime[0] = upload_frame.data.StepFlowStartTime[5];
	upload_frame_gs.data.Datetime[1] = upload_frame.data.StepFlowStartTime[4];
	upload_frame_gs.data.Datetime[2] = upload_frame.data.StepFlowStartTime[3];
	upload_frame_gs.data.Datetime[3] = upload_frame.data.StepFlowStartTime[2];
	upload_frame_gs.data.Datetime[4] = upload_frame.data.StepFlowStartTime[1];
	upload_frame_gs.data.Datetime[5] = upload_frame.data.StepFlowStartTime[0];
	//ʱθ
	upload_frame_gs.data.StepCnt = 48;
	//ʱ
	upload_frame_gs.data.Step[0] =0;
	upload_frame_gs.data.Step[1] =30;//30
	//ݶδ
	upload_frame_gs.data.DataCode = 0x20;
	//ͷжȣλ L6 ֽ 12 λ BCD 룬С
	u32HEXtoBCDData(upload_frame.data.CurrentFlow.datas, &temp_buf[0]);
	upload_frame_gs.data.StepFlow1[0] = temp_buf[5];
	upload_frame_gs.data.StepFlow1[1] = temp_buf[4];
	upload_frame_gs.data.StepFlow1[2] = temp_buf[3];
	upload_frame_gs.data.StepFlow1[3] = temp_buf[2];
	upload_frame_gs.data.StepFlow1[4] = temp_buf[1];
	upload_frame_gs.data.StepFlow1[5] = temp_buf[0];
	//ʱ
	for(int i=0; i<47; i++) 
	{
		tempData.data_buf[0] = upload_frame.data.StepFlow[i*2];
		tempData.data_buf[1] = upload_frame.data.StepFlow[i*2+1];
		tempData.data_buf[2] = 0;
		tempData.data_buf[3] = 0;						
		u32HEXtoBCDData(tempData.datas, &temp_buf[0]);
		upload_frame_gs.data.StepFlowN[i][0] = temp_buf[2];
		upload_frame_gs.data.StepFlowN[i][1] = temp_buf[1];
		upload_frame_gs.data.StepFlowN[i][2] = temp_buf[0];
	}
}
 
static void UploadData_GS_Current(void)
{
	U32_To_Float  temp_float_data;
	SS_UNION_4U8TOU32 tempData;
	DateTime tempRtcc_time;
	u8 temp_buf[6];
	
	RtccGetDateTime(&tempRtcc_time);//ϱʱ
	//ʼʱ
	upload_frame_gs.data.Datetime[0] = tempRtcc_time.s.year;
	upload_frame_gs.data.Datetime[1] = tempRtcc_time.s.month;
	upload_frame_gs.data.Datetime[2] = tempRtcc_time.s.day;
	upload_frame_gs.data.Datetime[3] = tempRtcc_time.s.hour;
	upload_frame_gs.data.Datetime[4] = tempRtcc_time.s.minute;
	upload_frame_gs.data.Datetime[5] = tempRtcc_time.s.second;
	//ʱθ
	upload_frame_gs.data.StepCnt = 1;
	//ʱ
	upload_frame_gs.data.Step[0] =0;
	upload_frame_gs.data.Step[1] =0;
	//ݶδ
	upload_frame_gs.data.DataCode = 0x20;
	//ͷжȣλ L6 ֽ 12 λ BCD 룬С
	temp_float_data.gp22_u32 =  Gp30CheckDataApp(2);
	tempData.datas  = (u32)(temp_float_data.gp22_float*10);
	u32HEXtoBCDData(tempData.datas, &temp_buf[0]);
	upload_frame_gs.data.StepFlow1[0] = temp_buf[5];
	upload_frame_gs.data.StepFlow1[1] = temp_buf[4];
	upload_frame_gs.data.StepFlow1[2] = temp_buf[3];
	upload_frame_gs.data.StepFlow1[3] = temp_buf[2];
	upload_frame_gs.data.StepFlow1[4] = temp_buf[1];
	upload_frame_gs.data.StepFlow1[5] = temp_buf[0];
}
//ʱϱݴ洢
void GS_TempSaveProc(void)
{
	u8 temp_buf[6];
	SS_UNION_4U8TOU32 tempData;
	u8 temp_index=(ls_save_cnt/48);
	if(temp_index < 6)
	{
		if((ls_save_cnt%48)==0)//µڿʼ
		{
			for(int i=0;i<STRU_DATA_LEN_GS;i++)
			{
				ls_save_buf[temp_index].buf[i] =0;
			}
			new_gs_total_flow.gp22_u32 = Gp30CheckDataApp(2);
			old_gs_total_flow.gp22_u32 = new_gs_total_flow.gp22_u32;
			//ʼʱ
			ls_save_buf[temp_index].data.Datetime[0] = GuangShui_rtcc_time.s.year;
			ls_save_buf[temp_index].data.Datetime[1] = GuangShui_rtcc_time.s.month;
			ls_save_buf[temp_index].data.Datetime[2] = GuangShui_rtcc_time.s.day;
			ls_save_buf[temp_index].data.Datetime[3] = GuangShui_rtcc_time.s.hour;
			ls_save_buf[temp_index].data.Datetime[4] = GuangShui_rtcc_time.s.minute;
			ls_save_buf[temp_index].data.Datetime[5] = GuangShui_rtcc_time.s.second;
			//ʱθ0
			ls_save_buf[temp_index].data.StepCnt = 0;
			//ʱ
			ls_save_buf[temp_index].data.Step[0] =linshi_jm.Data.data_interval.data_buf[1];
			ls_save_buf[temp_index].data.Step[1] =linshi_jm.Data.data_interval.data_buf[0];
			//ݶδ
			ls_save_buf[temp_index].data.DataCode = 0x20;
			//ͷжȣλ L6 ֽ 12 λ BCD 룬С
			tempData.datas  = (u32)(new_gs_total_flow.gp22_float*10);
			u32HEXtoBCDData(tempData.datas, &temp_buf[0]);
			ls_save_buf[temp_index].data.StepFlow1[0] = temp_buf[5];
			ls_save_buf[temp_index].data.StepFlow1[1] = temp_buf[4];
			ls_save_buf[temp_index].data.StepFlow1[2] = temp_buf[3];
			ls_save_buf[temp_index].data.StepFlow1[3] = temp_buf[2];
			ls_save_buf[temp_index].data.StepFlow1[4] = temp_buf[1];
			ls_save_buf[temp_index].data.StepFlow1[5] = temp_buf[0];
			ls_save_buf[temp_index].data.StepCnt++;
		}
		else
		{
			new_gs_total_flow.gp22_u32 = Gp30CheckDataApp(2);
			jiange_data.datas = (u16)((new_gs_total_flow.gp22_float - old_gs_total_flow.gp22_float)*10);
			old_gs_total_flow.gp22_u32 = new_gs_total_flow.gp22_u32;
			
			tempData.data_buf[0] = jiange_data.datas_map.data0;
			tempData.data_buf[1] = jiange_data.datas_map.data1;
			tempData.data_buf[2] = 0;
			tempData.data_buf[3] = 0;						
			u32HEXtoBCDData(tempData.datas, &temp_buf[0]);
			ls_save_buf[temp_index].data.StepFlowN[ls_save_buf[temp_index].data.StepCnt-1][0] = temp_buf[2];
			ls_save_buf[temp_index].data.StepFlowN[ls_save_buf[temp_index].data.StepCnt-1][1] = temp_buf[1];
			ls_save_buf[temp_index].data.StepFlowN[ls_save_buf[temp_index].data.StepCnt-1][2] = temp_buf[0];
			ls_save_buf[temp_index].data.StepCnt++;
		}
		ls_save_cnt++;
	}
}


int GetUploadDataCount(void)
{
	if (Sys_data_object.P1.histroy_w >= Sys_data_object.P1.histroy_r)
		return (Sys_data_object.P1.histroy_w - Sys_data_object.P1.histroy_r);
	else 
		return (Sys_data_object.P1.histroy_w + PERIOD_DATA_NUM - Sys_data_object.P1.histroy_r);
}

void GetUploadDataResetState_GS(void)
{
	upload_frame_stat_GuangShui =UP_DEAL_S0;
	upload_task_complete_GuangShui = PTL_PACK_BUSY;
}
u8 GetUploadDataCheckIdle_GS(void)
{
	if(UP_DEAL_S0 == upload_frame_stat_GuangShui)
    {
        return TASK_IDLE;
    }
    else
    {
        return TASK_BUSY;
    }
}
u8 GetUploadDataCheckTask_GS(void)
{
	return upload_task_complete_GuangShui;
}

void GetUploadDataMachine_GS(u8 data_step, u8* p_send_buf, u16* p_send_len)
{
	switch(upload_frame_stat_GuangShui)
	{
		case UP_DEAL_S0:
		{
			if(data_step == UPLOAD_FRAME_REQUEST_NEW)//ݰ
			{
				temp_upload_step = 0;
				upload_frame_retry_times = 0;//ط0
				upload_frame_stat_GuangShui = UP_DEAL_S1;
			}
			else if(data_step == UPLOAD_FRAME_UPLOAD_OK)//ͳɹ
			{
				gs_upload_fail_times = 0;
				upload_frame_retry_times = 0;//ط0
				if(temp_upload_step == UP_DEAL_S10)//ʷ
				{
					Sys_data_object.P1.histroy_r++;
					if(Sys_data_object.P1.histroy_r >= PERIOD_DATA_NUM)
					{
						Sys_data_object.P1.histroy_r = 0;
					}
					setStoreMsg(SS_StoreMsg3, TRUE);//дָ
					upload_frame_stat_GuangShui = UP_DEAL_S1;//ϱһ
				}
				else if(temp_upload_step == UP_DEAL_S11)//ǰϱɹ,
				{
					upload_task_complete_GuangShui = PTL_PACK_FAIL;
					upload_frame_stat_GuangShui = UP_DEAL_S0;
				}
				else if(temp_upload_step == UP_DEAL_S30)//ʱϱ
				{
					if(ls_upload_index < ls_save_cnt/48)
					{
						ls_upload_index++;
						upload_frame_stat_GuangShui = UP_DEAL_S30;
					}
					else
					{
						upload_task_complete_GuangShui = PTL_PACK_FAIL;
						upload_frame_stat_GuangShui = UP_DEAL_S0;
					}
				}
			}
			else if(data_step == UPLOAD_FRAME_UPLOAD_RETRY)//·
			{
				upload_frame_stat_GuangShui = UP_DEAL_S21;
			}
			else if(data_step == UPLOAD_FRAME_ONLINE_FAIL) //ʧ
			{
				if(ls_upload_flag)//ʱϱ
				{
					ls_upload_flag = 0;//ʱϱ־
				}
				else
				{
					if(UPLOAD_TYPE_FIX_TIME == GetEventUploadType())//ʱϴ
					{
						setStoreMsg(SS_StoreMsg1, TRUE);//ǲλ
						SystemAddUploadAgain();//ش
					}
					else if(UPLOAD_TYPE_RETRY_AGAIN == GetEventUploadType())//ش
					{
						SystemAddUploadAgain();//ش
					}
				}	
				gs_upload_fail_times++;//ʧܴ				
				upload_task_complete_GuangShui = PTL_PACK_FAIL;
				upload_frame_stat_GuangShui = UP_DEAL_S0;
			}
			else 
			{
				ls_upload_flag = 0;//ʱϱ־
				upload_task_complete_GuangShui = PTL_PACK_FAIL;
				upload_frame_stat_GuangShui = UP_DEAL_S0;
			}
		}
		break;
		case UP_DEAL_S1:
		{
			if(ls_upload_flag)//ʱϱ
			{
				upload_frame_stat_GuangShui = UP_DEAL_S30;
			}
			else
			{
				if(EepIfIdle())
				{
					upload_packet_count = GetUploadDataCount();
					if(upload_packet_count > 0)
					{
						EepRead(EEP_ADDR_CIRCLE_DATA+(Sys_data_object.P1.histroy_r*PACK_NUM_GPRS), &upload_frame.buf[0], PACK_NUM_GPRS, &s_eep_complete_GuangShui);
						upload_frame_stat_GuangShui = UP_DEAL_S10;
					}
					else//ûм¼,ϱһǰ
					{
						upload_frame_stat_GuangShui = UP_DEAL_S11;
					}
				}
			}
		}
		break;
		case UP_DEAL_S10://תˮЭϱ֡
		{
			if(EepIfIdle())
			{
				temp_upload_step = UP_DEAL_S10;
				UploadData_GS();
				upload_temp_len_GuangShui = STRU_DATA_LEN_GS;//ϱݳ
				upload_frame_stat_GuangShui = UP_DEAL_S20;
			}
		}
		break;
		case UP_DEAL_S11://ǰ֡
		{
			if(EepIfIdle())
			{
				temp_upload_step = UP_DEAL_S11;
				UploadData_GS_Current();
				upload_temp_len_GuangShui = STRU_DATA_LEN_GS_CURRENT;
				upload_frame_stat_GuangShui = UP_DEAL_S20;
			}
		}
		break;
		case UP_DEAL_S20://ϴ֡
		{
			if(EepIfIdle())
			{
				upload_struct_GuangShui.ack_ctrl = 0x01;
				Frame_ack_GS(upload_struct_GuangShui, upload_frame_gs.buf, upload_temp_len_GuangShui, p_send_buf, p_send_len);
				upload_task_complete_GuangShui = PTL_PACK_SUCCESS;// ɹ
				upload_frame_stat_GuangShui = UP_DEAL_S0;
			}
		}
		break;
		case UP_DEAL_S21://
		{
			if(upload_frame_retry_times < 3) 
			{
				upload_frame_retry_times++;
				upload_frame_stat_GuangShui = UP_DEAL_S20;
			} 
			else//·ʧ3εĴ
			{
				if(temp_upload_step == UP_DEAL_S1)//ǰʧ,жǷ񲹱
				{
					if(UPLOAD_TYPE_FIX_TIME == GetEventUploadType())//ʱϴ
					{
						SystemAddUploadAgain();//ش
						gs_upload_fail_times++;//ʧܴ
					}
					else if(UPLOAD_TYPE_RETRY_AGAIN == GetEventUploadType())//ش
					{
						SystemAddUploadAgain();//ش
					}
				}
				upload_task_complete_GuangShui = PTL_PACK_FAIL;
				upload_frame_stat_GuangShui = UP_DEAL_S0;
			}
		}
		break;
		case UP_DEAL_S30://ʱϱ֡
		{
			temp_upload_step = UP_DEAL_S30;
			if(ls_upload_index <= ls_save_cnt/48)
			{
				for(int i=0;i<STRU_DATA_LEN_GS;i++)
				{
					upload_frame_gs.buf[i] = ls_save_buf[ls_upload_index].buf[i];
				}
				upload_temp_len_GuangShui = STRU_DATA_LEN_GS;//ܼϱݳ
				upload_frame_stat_GuangShui = UP_DEAL_S20;
			}
			else
			{
				ls_upload_flag = 0;//ʱϱ־
				upload_task_complete_GuangShui = PTL_PACK_FAIL;
				upload_frame_stat_GuangShui = UP_DEAL_S0;
			}
		}
		break;
		default:
		{
			ls_upload_flag = 0;//ʱϱ־
			upload_task_complete_GuangShui = PTL_PACK_FAIL;
			upload_frame_stat_GuangShui = UP_DEAL_S0;
		}
		break;
	}
}
/*************************************************Լݴ洢****************************/
//־洢
static void SS_Store_SuppleFlagMachine(void)
{
	switch(step_clear_flag)
	{
		case SS_STATE_S0:
		{
			if(getStoreMsg(SS_StoreMsg1) == TRUE)//油־
			{
				setStoreMsg(SS_StoreMsg1,FALSE);
				Sys_data_object.P1.Supplemental_send_flag.datas |=(0x00001<<Sys_data_object.P1.histroy_r);
				step_clear_flag = SS_STATE_S1;
			}
			else if(getStoreMsg(SS_StoreMsg2) == TRUE)//嵱ǰ־
			{
				setStoreMsg(SS_StoreMsg2,FALSE);
				Sys_data_object.P1.Supplemental_send_flag.datas &=(~(0x0001<<(Sys_data_object.P1.histroy_r)));
				step_clear_flag = SS_STATE_S1;
			}
			else if(getStoreMsg(SS_StoreMsg5) == TRUE)//в־
			{
				setStoreMsg(SS_StoreMsg5,FALSE);
				Sys_data_object.P1.Supplemental_send_flag.datas = 0;
				step_clear_flag = SS_STATE_S1;
			}
		}
		break;
		case SS_STATE_S1:
		{
			if(EepIfIdle())
			{		
				EepWrite(&Sys_data_object.P1.Supplemental_send_flag.datas_map.data0, FRAME_NBIot_BUBAO_FLAG, 6, &s_eep_complete_GuangShui);
				step_clear_flag = SS_STATE_WAIT;
			}
		}
		break;
		case SS_STATE_WAIT:
		{
			if(EepIfIdle())
			{		
				step_clear_flag = SS_STATE_S0;
			}
		}
		break;

		default:
		{
			step_clear_flag = SS_STATE_S0;
		}
		break;
	}
}

//ݴ洢
static void SS_Store_CircleDataMachine(void)
{
	switch (step_save_supplt)//ݴ洢
	{
		case SS_STATE_S0://洢Ϣж
		{
			if (RtccCheckMsgApp(RtccMsg_OtherProtl))
			{
				RtccClearMsgApp(RtccMsg_OtherProtl);
				setStoreMsg(SS_StoreMsg6,TRUE);//ʷݴ洢Ϣ
				RtccGetDateTime(&GuangShui_rtcc_time);
				if(get_lset_judg(&ls_save,&ls_up))
				{
					if(ls_save)
					{
						setStoreMsg(SS_StoreMsg7,TRUE);//ʱ洢Ϣ
					}
					if(ls_up)
					{
						ls_up=FALSE;
						FrameSetMsgApp(MsgShenYang_NbUploadWarning);
						ls_upload_flag = 1;
					}
				}
				if((GuangShui_rtcc_time.s.minute==0x00)||(GuangShui_rtcc_time.s.minute==0x30))
				{
					FrameSetMsgApp(MsgSS_JianGeStore);//Сʱ洢Ϣ
				}
				if ((GuangShui_rtcc_time.s.hour == 0)&&(GuangShui_rtcc_time.s.minute==0x00))//ʱ䵽
				{
					//:2B()X2(/h)X24h=96B
					for(int i = 0; i <96 ;i++)//
					{
						store_frame.data.StepFlow[i] = 0;
					}
					//ʼ
					new_jiange_total_flow.gp22_u32 = Gp30CheckDataApp(2);
					old_jiange_total_flow.gp22_u32 = new_jiange_total_flow.gp22_u32;
					//洢Ϣ
					RtccSetMsgApp(RtccMsg_DataSave);//0¶
					FrameSetMsgApp(MsgSS_HisIndexStore);//0¶ָ
				}
			}
			/**Ͷݴ洢0洢; Ȼ洢ָ; ʼµһּ洢,ڼждָЧ;*/

			if(FrameCheckMsgApp(MsgSS_HisIndexStore))//0¶ָ
			{
				FrameClearMsgApp(MsgSS_HisIndexStore);
				step_save_supplt = SS_STATE_S2;
			}
			else if(RtccCheckMsgApp(RtccMsg_DataSave))//0㱣涳
			{
				RtccClearMsgApp(RtccMsg_DataSave);
				step_save_supplt = SS_STATE_S10;
			}
			else if(FrameCheckMsgApp(MsgSS_JianGeStore)) //Сʱ洢
			{
				FrameClearMsgApp(MsgSS_JianGeStore);
				step_save_supplt = SS_STATE_S20;
			}
			
			else if(FrameCheckMsgApp(Msg_ClearHisOther))//
			{
				FrameClearMsgApp(Msg_ClearHisOther);
				step_save_supplt = SS_STATE_S40;
			} 
			else if(getStoreMsg(SS_StoreMsg3) == TRUE)//в־
			{
				setStoreMsg(SS_StoreMsg3,FALSE);
				step_save_supplt = SS_STATE_S3;
			}
			else if(getStoreMsg(SS_StoreMsg7) == TRUE)//ʱ洢
			{
				setStoreMsg(SS_StoreMsg7,FALSE);
				step_save_supplt = SS_STATE_S30;
			}
			break;
		}
		/*0¶*/
		case SS_STATE_S10:
		{
			if(TASK_IDLE == EepIfIdle())
			{
				//(ֻ)±ݺͱ״̬
				Upload_RenewCurrentData(&store_frame);
			    EepWrite(store_frame.buf, (EEP_ADDR_CIRCLE_DATA+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)), CURRENT_DATA_INFO_LEN, &s_eep_complete_GuangShui);
				step_save_supplt = SS_STATE_S11;
			}
		    break;
		}
		case SS_STATE_S11://ϱʱ 
		{
			if(TASK_IDLE == EepIfIdle())
			{
			    EepWrite(&store_frame.data.UploadTime[0], (EEP_ADDR_CIRCLE_DATA+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)+UPLOAD_TIME_ADDR), 7, &s_eep_complete_GuangShui);
				step_save_supplt = SS_STATE_WAIT;
			}
		    break;
		} 
		/*0¶ָ*/
		case SS_STATE_S2:
		{
			if(TASK_IDLE == EepIfIdle())
			{			
				Sys_data_object.P1.histroy_w++;
				if(Sys_data_object.P1.histroy_w>=PERIOD_DATA_NUM) 
				{
					Sys_data_object.P1.histroy_w=0; 
				}				
				Sys_data_object.P1.Supplemental_send_flag.datas &=(~(0x0001<<(Sys_data_object.P1.histroy_w)));//λò־
				EepWrite(&Sys_data_object.P1.Supplemental_send_flag.datas_map.data0, FRAME_NBIot_BUBAO_FLAG, 6, &s_eep_complete_GuangShui);
				step_save_supplt = SS_STATE_WAIT;
			}	
			break;					
		}
		case SS_STATE_S3://ָ
		{
			if(TASK_IDLE == EepIfIdle())
			{			
				EepWrite(&Sys_data_object.P1.histroy_r, (FRAME_NBIot_BUBAO_FLAG+4), 2, &s_eep_complete_GuangShui);
				step_save_supplt = SS_STATE_WAIT;
			}	
			break;					
		}
		/*洢*/
		case SS_STATE_S20://Сʱʱж:ֹ״ϵ,ڱ
		{
			if(EepIfIdle())
			{		
				if(	(GuangShui_rtcc_time.s.year  == store_frame.data.StepFlowStartTime[5])&&
					(GuangShui_rtcc_time.s.month == store_frame.data.StepFlowStartTime[4])&&
					(GuangShui_rtcc_time.s.day   == store_frame.data.StepFlowStartTime[3]))
				{
					step_save_supplt = SS_STATE_S22;
				}
				else
				{	
					EepRead(EEP_ADDR_CIRCLE_DATA+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)+STEP_FLOW_TIME_ADDR, &store_frame.data.StepFlowStartTime[0], 7, &s_eep_complete_GuangShui);
					step_save_supplt = SS_STATE_S21;
				}
			}
		}
		break;
		case SS_STATE_S21:
		{
			if(EepIfIdle())
			{		
				if(	(GuangShui_rtcc_time.s.year  == store_frame.data.StepFlowStartTime[5])&&
					(GuangShui_rtcc_time.s.month == store_frame.data.StepFlowStartTime[4])&&
					(GuangShui_rtcc_time.s.day   == store_frame.data.StepFlowStartTime[3]))
				{
					step_save_supplt = SS_STATE_S22;
				}
				else//Ч,еǰʼ
				{
					//ȡݺͱ״̬
					Upload_RenewCurrentData(&store_frame);
					//ϱźŲ
					store_frame.data.UploadInfo.metinfo.ecl_val =0;
					store_frame.data.UploadInfo.metinfo.RSRP_val =0;
					store_frame.data.UploadInfo.metinfo.single_val =0;
					store_frame.data.UploadInfo.metinfo.snr_val =0;
					//ʼʱ
					store_frame.data.StepFlowStartTime[0]= 0x00;
					store_frame.data.StepFlowStartTime[1]= 0x00;
					store_frame.data.StepFlowStartTime[2]= 0x00;
					store_frame.data.StepFlowStartTime[3]= GuangShui_rtcc_time.s.day;
					store_frame.data.StepFlowStartTime[4]= GuangShui_rtcc_time.s.month;
					store_frame.data.StepFlowStartTime[5]= GuangShui_rtcc_time.s.year;        
					store_frame.data.StepFlowStartTime[6]= 0x20; 
					//:2B()X2(/h)X24h=96B
					for(int i = 0; i <96 ;i++)//
					{
						store_frame.data.StepFlow[i] = 0;
					}
					if(Sys_data_object.P1.histroy_w>=PERIOD_DATA_NUM) 
					{
						Sys_data_object.P1.histroy_w=0; 
					}
					EepWrite(store_frame.buf, (EEP_ADDR_CIRCLE_DATA+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)), PACK_NUM_GPRS, &s_eep_complete_GuangShui);
				}
			}
		}
		break;
		case SS_STATE_S22://洢ĳ
		{
			if(EepIfIdle())
			{		
				u16 temp_step_flow_addr=0;
				//
				new_jiange_total_flow.gp22_u32 = Gp30CheckDataApp(2);
				jiange_data.datas = (u16)((new_jiange_total_flow.gp22_float - old_jiange_total_flow.gp22_float)*10);
				old_jiange_total_flow.gp22_u32 = new_jiange_total_flow.gp22_u32;
			    //㱾ʱ̼洢λ
				temp_step_flow_addr = EEP_ADDR_CIRCLE_DATA+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)+STEP_FLOW_START_ADDR + 
				                      BCD2HEX(GuangShui_rtcc_time.s.hour)*4 + (BCD2HEX(GuangShui_rtcc_time.s.minute)/30)*2;
				EepWrite(&jiange_data.datas_map.data0, temp_step_flow_addr, 2, &s_eep_complete_GuangShui);
				step_save_supplt = SS_STATE_WAIT;
			}
		}
		break;
		//ʱ洢
		case SS_STATE_S30:
		{
			GS_TempSaveProc();
			step_save_supplt = SS_STATE_S0;
		}
		break;
		/*ݳʼдָ*/
		case SS_STATE_S40:
		{
			if(TASK_IDLE == EepIfIdle())
			{			
				//ʼ
				new_jiange_total_flow.gp22_u32 = Gp30CheckDataApp(2);
				old_jiange_total_flow.gp22_u32 = new_jiange_total_flow.gp22_u32;
				for(int i=0;i<7;i++)
				{
					store_frame.data.StepFlowStartTime[i]= 0x00;
				}
				Sys_data_object.P1.histroy_w = 0;
				Sys_data_object.P1.histroy_r = 0;
				Sys_data_object.P1.Supplemental_send_flag.datas = 0;//Ҳ0		
				EepWrite(&Sys_data_object.P1.Supplemental_send_flag.datas_map.data0, FRAME_NBIot_BUBAO_FLAG, 6, &s_eep_complete_GuangShui);
				step_save_supplt = SS_STATE_WAIT;
			}	
			break;					
		}
		case SS_STATE_WAIT:
		{
            if(TASK_IDLE == EepIfIdle())
            {
                 step_save_supplt = SS_STATE_S0;
            }
            break;
		}
        default:
        {
            break;		
        }			
    }
}

//ʷݴ洢
static void SS_Store_HisDataMachine(void)
{
	switch(his_save_step) 
	{
		case SS_STATE_S0:
		{
			if(getStoreMsg(SS_StoreMsg6) == TRUE)//ʷݴ洢ÿж
			{
				setStoreMsg(SS_StoreMsg6,FALSE);
				save_his_interval_cnt++;
			}
			if(save_his_interval_cnt > his_save_para.Data.Period.datas)
			{
				save_his_interval_cnt = 0;
				his_save_step = SS_STATE_S1;
			}
		}
		break;
		case SS_STATE_S1:
		{
			if(TASK_IDLE == EepIfIdle())
            {
                his_save_flow_value.gp22_u32 = Gp30CheckDataApp(2);
				his_save_flow_buf[0] = his_save_flow_value.buf[0];
				his_save_flow_buf[1] = his_save_flow_value.buf[1];
				his_save_flow_buf[2] = his_save_flow_value.buf[2];
				his_save_flow_buf[3] = his_save_flow_value.buf[3];
				his_save_flow_buf[4] = his_save_flow_buf[0]+his_save_flow_buf[1]+his_save_flow_buf[2]+his_save_flow_buf[3];
				his_save_addr = EEP_ADDR_HIS_DATA+((his_save_para.Data.Index_w.datas%GS_HIS_STORE_MAX)*5);//㱾ʱ洢λ
				EepWrite(&his_save_flow_buf[0], his_save_addr, 5, &s_eep_complete_GuangShui);
				his_save_step = SS_STATE_S2;
            }
		}
		break;
		case SS_STATE_S2://洢ָ
		{
			if(TASK_IDLE == EepIfIdle())
            {
				his_save_para.Data.Index_w.datas++;
				EepWrite(&his_save_para.Data.Index_w.data_buf[0], EEP_ADDR_HIS_INDEX, 4, &s_eep_complete_GuangShui);
				his_save_step = SS_STATE_S0;
            }
		}
		break;
		default:
		{
			his_save_step = SS_STATE_S0;
		}
		break;
		
	}
}


/*******************************************************************************
 * @fun_name:NB_SS_Control_GetPara
 * @brief   :    
 * @param[in] :ȡϱز
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
u8 NB_SS_Control_GetPara(NB_SS_ControlParaTypeDef paraType)
{
    switch(paraType)
	{
	    case NB_HistroyReadIndex://ʷݵĶָ
		{
			return Sys_data_object.P1.histroy_w;
		}
		case NB_UploadFailTimes://ʧܴ
		{
			u8 temp_fail_times=0;
			if(Sys_data_object.P3.ProductUpoadFailFlag)
			{
				temp_fail_times = Sys_data_object.P3.ProductUpoadFailFlag;
			}
			else
			{
				temp_fail_times = gs_upload_fail_times;
			}
			return temp_fail_times;
		}
		case NB_SS_FormatError://ϱݸʽ
		{
			return signal_val.SignalStruct.format_error;
		}
		default:
			break;
	}
	return 0;
}
/*******************************************************************************
 * @fun_name:NB_SS_Control_SetPara
 * @param[in] :ϱز
 ******************************************************************************/
void NB_SS_Control_SetPara(NB_SS_ControlParaTypeDef paraType, u8 data)
{
    switch(paraType)
	{
	    case NB_HistroyReadIndex://ʷݵĶָ
		{
			Sys_data_object.P1.histroy_w = data;
			break;
		}
		case NB_UploadFailTimes://ʧܴ
		{
			SystemClearUploadAgain();
			Sys_data_object.P1.Supplemental_send_flag.datas = data;
			Sys_data_object.P3.ProductUpoadFailFlag = 0;
			gs_upload_fail_times =0;
			setStoreMsg(SS_StoreMsg5,TRUE);//EEPROM
			break;
		}
		case NB_SS_FormatError://ϱݸʽ
		{
			signal_val.SignalStruct.format_error = data;
			break;
		}
		default:
			break;
	}
}

void GuangShui_Store_InitApp(void)
{
    TYP_STATE_QZ tmp_init_stat = QZ_STATE_S0;
	if(Sys_data_object.P3.FirstPowerOnFlag == FIRST_POWER_ON_FLAG)
	{
		tmp_init_stat = QZ_STATE_S10;
	}
	else
	{
		tmp_init_stat = QZ_STATE_S20;
	}
    while (tmp_init_stat)
    {
      switch (tmp_init_stat)
      {
        case QZ_STATE_S0:
        {
			if (TASK_IDLE == EepIfIdle())
            {
                tmp_init_stat = QZ_STATE_S0;
            }
            break;
        }
        case QZ_STATE_S10://һϵ,ʷݴ洢
        {
            if(TASK_IDLE == EepIfIdle())
            {
				his_save_para.Data.Period.datas = 1440;//Ĭ1洢
				his_save_para.Data.Index_w.datas = 0;
				EepWrite(&his_save_para.data_buf[0], EEP_ADDR_HIS_INDEX, 6, &s_eep_complete_GuangShui);//ʷݴ洢
                tmp_init_stat = QZ_STATE_S11;
            }
            break;
        }
		case QZ_STATE_S11://һϵ,ʱݴ洢ϱ
        {
            if(TASK_IDLE == EepIfIdle())
            {
				linshi_jm.Data.up_interval.datas = 240;//4Сʱϱ
				linshi_jm.Data.data_interval.datas = 5;//5Ӵ洢
				EepWrite(&his_save_para.data_buf[0], EEP_ADDR_HIS_INDEX, 6, &s_eep_complete_GuangShui);//ʷݴ洢
                tmp_init_stat = QZ_STATE_S1;
            }
            break;
        }
		case QZ_STATE_S20://ǵһϵ,ȡʷݴ洢
        {
            if (TASK_IDLE == EepIfIdle())
            {
                EepRead(EEP_ADDR_HIS_INDEX, &his_save_para.data_buf[0], 6, &s_eep_complete_GuangShui);
                tmp_init_stat = QZ_STATE_S21;				
            }
            break;			
        }
		case QZ_STATE_S21://ǵһϵ,ȡʱݴ洢ϱ
		{
			if (TASK_IDLE == EepIfIdle())
            {
                EepRead(EEP_ADDR_TEMP_STORE_UPLOAD, &linshi_jm.data_buf[0], 8, &s_eep_complete_GuangShui);
                tmp_init_stat = QZ_STATE_S1;				
            }	
			break;
		}
		case QZ_STATE_S1:
		{
			if (TASK_IDLE == EepIfIdle())
            {
                tmp_init_stat = QZ_STATE_S0;				
            }
			break;
		}
		default:
		{
			tmp_init_stat  =QZ_STATE_S0;
		    break;
		}
      }
      EepMachineDriver();
    }
	if(his_save_para.Data.Index_w.datas>0x80000000)
	{
		his_save_para.Data.Index_w.datas =0;
	}
}
/****************************ݴ洢ֹýӿ*********************************************/
//Լݴ洢ֳʼ
void DataStoreInit(void)
{
	Quanzhou_Store_InitApp();
	GuangShui_Store_InitApp();
	if(Sys_data_object.P1.histroy_w>=PERIOD_DATA_NUM) 
	{
		Sys_data_object.P1.histroy_w=0; 
	}
	if(Sys_data_object.P1.histroy_r>=PERIOD_DATA_NUM) 
	{
		Sys_data_object.P1.histroy_r=0; 
	}
	old_jiange_total_flow.gp22_u32  = Gp30CheckDataApp(GP30_APP_TOTAL_FLOW);//ʼ
}
//Լݴ洢״̬
void DataStoreMachine(void)
{
	SS_Store_SuppleFlagMachine();//־洢
	SS_Store_CircleDataMachine();//ݴ洢
	Quanzhou_Store_Machine();//ݴ洢
	SS_Store_HisDataMachine();//ʷݴ洢
}
//Լݴ洢ж
u8 DataStoreIfIdle(void)
{
    if((step_save_supplt == SS_STATE_S0)&&(step_clear_flag == SS_STATE_S0)&&(QuanzhouStore_IfSleep()==TRUE))
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

#endif

